/*---------------------------------------------------------------------------*
  Project:  TwlBrom - alarm
  File:     main.c

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#include <brom.h>

static void handler(void)
{
}

void BromMain( void )
{
    osTPrintf( "start mon0 = %08x\n", osGetPerfMonitor( OS_MONITOR_0 ) );
    osTPrintf( "start mon1 = %08x\n", osGetPerfMonitor( OS_MONITOR_1 ) );
    osTPrintf( "start mon2 = %08x\n", osGetPerfMonitor( OS_MONITOR_2 ) );

    osInitException();
    osInitBROM();

    osPrintf( "ARM11: start\n" );

    //---- Init Alarm
    osInitAlarm();
    {
        static OSAlarm alarm;
        OSTick interval = OS_MSEC_TO_TICK(1000);
        osCreateAlarm( &alarm );
        osSetPeriodicAlarm(&alarm, osGetTick()+interval, interval, (OSAlarmHandler)handler, NULL);
    }

    while (1)
    {
        OSTick tick = osGetTick();
        u32 pmon[OS_MONITOR_NUM];
        pmon[0] = osGetPerfMonitor( OS_MONITOR_0 );
        pmon[1] = osGetPerfMonitor( OS_MONITOR_1 );
        pmon[2] = osGetPerfMonitor( OS_MONITOR_2 );
        osWaitInterruptID( TRUE, OSi_ALARM_IE_TIMER_ID );
        pmon[0] = osGetPerfMonitor( OS_MONITOR_0 ) - pmon[0];
        pmon[1] = osGetPerfMonitor( OS_MONITOR_1 ) - pmon[1];
        pmon[2] = osGetPerfMonitor( OS_MONITOR_2 ) - pmon[2];
        tick = osGetTick() - tick;
        osTPrintf( "wait mon0 = %llu msec\n", OS_TICK_TO_MSEC(pmon[0]) );
        osTPrintf( "wait mon1 = %llu msec\n", OS_TICK_TO_MSEC(pmon[1]) );
        osTPrintf( "wait mon2 = %llu msec\n", OS_TICK_TO_MSEC(pmon[2]) );
        osTPrintf( "wait tick = %llu msec\n", OS_TICK_TO_MSEC(tick) );
    }
}

