/*---------------------------------------------------------------------------*
  Project:  TwlBrom - alarm
  File:     main.c

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#include <brom.h>

static void handler(void)
{
}

void BromSpMain( void )
{
    osInitException();
    osInitBROM();

    osPrintf( "ARM9: start\n" );

    //---- Init Alarm
    osInitAlarm();
    {
        static OSAlarm alarm;
        OSTick interval = OS_MSEC_TO_TICK(1000);
        osCreateAlarm( &alarm );
        osSetPeriodicAlarm(&alarm, osGetTick()+interval, interval, (OSAlarmHandler)handler, NULL);
    }

    while (1)
    {
        OSTick tick = osGetTick();
        osWaitInterruptID( TRUE, OSi_ALARM_IE_TIMER_ID );
        tick = osGetTick() - tick;
        osTPrintf( "wait tick = %llu msec\n", OS_TICK_TO_MSEC(tick) );
    }
}

