/*---------------------------------------------------------------------------*
  Project:  CtrBrom - library - init
  File:     crt0.c

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#include <brom/code32.h>
#include <brom/os.h>

void    _start(void);

/*---------------------------------------------------------------------------*
  Name:         _start

  Description:  Start up

  Arguments:    None

  Returns:      None.
 *---------------------------------------------------------------------------*/
asm void _start( void )
{
        PRESERVE8

        CODE32  // for _start reference

        INASM_EXTERN( i_stupIrqVeneer )
        INASM_EXTERN( i_stupFiqVeneer )
        INASM_EXTERN( i_stupSwiVeneer )
        INASM_EXTERN( i_stupUndefVeneer )
        INASM_EXTERN( i_stupIAbtVeneer )
        INASM_EXTERN( i_stupDAbtVeneer )

        b       stupStartHandlerVeneer  // don't change for NULL access compatibility
undef   b       i_stupUndefVeneer
swi     b       i_stupSwiVeneer
iabt    b       i_stupIAbtVeneer
dabt    b       i_stupDAbtVeneer
reserve b       reserve
irq     b       i_stupIrqVeneer
fiq     b       i_stupFiqVeneer

        INASM_EXTERN( i_stupSwiHandler )

        DCD     i_stupSwiHandler

        INASM_EXTERN( |Image$$SVC_RW$$Base| )
        INASM_EXTERN( |Load$$SVC_RW$$Base| )

        DCD |Image$$SVC_RW$$Base|
        DCD |Load$$SVC_RW$$Base|

stupStartHandlerVeneer

        INASM_EXTERN( i_stupStartHandler )

        b       i_stupStartHandler
}
