
#include <brom.h>
#include "crc.h"


/*---------------------------------------------------------------------------*
    globalϐ
 *---------------------------------------------------------------------------*/
static const u16 cr16_table[16] = {
    0x0000, 0xCC01, 0xD801, 0x1400,
    0xF001, 0x3C00, 0x2800, 0xE401,
    0xA001, 0x6C00, 0x7800, 0xB401,
    0x5000, 0x9C01, 0x8801, 0x4400,
};


/*---------------------------------------------------------------------------*
  Name:         crcCalc

  Description:  CRCiCRC-ANSI, ʖCRC16jZo

  Arguments:    data : 
    			len : 

  Returns:      
 *---------------------------------------------------------------------------*/
u16 crcCalc( vu8* data, vu16 len)
{
    vu16 r1, total;

    total = 0;
    while( len-- > 0) {
        /*4bit*/
        r1 = cr16_table[ total & 0xf];
        total = (total >> 4) & 0x0FFF;
		total = total ^ r1 ^ cr16_table[ *data & 0xf];

		/*4bit*/
		r1 = cr16_table[ total & 0xf];
		total = (total >> 4) & 0x0fff;
		total = total ^ r1 ^ cr16_table[ (*data >> 4) & 0xf];

		/*̃oCg*/
		data++;
	}
	return total;
}
