/*---------------------------------------------------------------------------*
  Project:  CTR - NAND driver
  File:     nandif_ip.h

  Copyright 2006 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef    __NAND_IF_IP_H__
#define    __NAND_IF_IP_H__


#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------*
  萔`
 *---------------------------------------------------------------------------*/
#define NAND_PAGE_DATASIZE     (2048)
#define NAND_PAGE_SPARESIZE    (64)
#define NAND_PAGE_ALLSIZE      (NAND_PAGE_DATASIZE + NAND_PAGE_SPARESIZE)


/*---------------------------------------------------------------------------*
  \
 *---------------------------------------------------------------------------*/
typedef struct NandSpareFormat {/*XyÄ 64oCg*/
    u8  block_stat_bad;         // 1 ubNXe[^XiobhubNj
    u8  block_stat_warning;     // 1 ubNXe[^XiӃubNj
    u8  page_stat;              // 1 y[WXe[^X
    u8  pad0;                   // 1
    u32 block_erase_count0;     // 4 ubN񐔁ipeBtj
    u16 logical_adr0;           // 2 _AhXipeBtj
    u16 pad1;                   // 2
    u32 ecc[4];                 //16 ECC 0`3
    u32 block_erase_count1;     // 4 ubN񐔁ipeBtj\
    u16 logical_adr1;           // 2 _AhXipeBtj\
    u16 pad2;                   // 2
    char sig0[4];               // 4 Signature"CTR\0"
    char sig1[4];               // 4 Signature"CTR\0"
    u8  reserve[20];            //28 \
} NandSpareFormat;

typedef struct NandDataFormat { /*f[^̈ 2048oCg*/
    u32 data[4][512/4];
/*    u32    data0[512/4];      //f[^̈1/4(512oCg)
    u32    data1[512/4];        //f[^̈2/4(512oCg)
    u32    data2[512/4];        //f[^̈3/4(512oCg)
    u32    data3[512/4];        //f[^̈4/4(512oCg)*/
} NandDataFormat;

typedef struct NandPageFormat {        /*y[WS*/
  struct NandDataFormat  data;
  struct NandSpareFormat spare; //XyÄ(64oCg)
} NandPageFormat;


/*
typedef struct NandSysFormat {
  u16 logical_adr;
  u16 read_count;
  u32 erase_count;
} NandSysFormat;*/



/*---------------------------------------------------------------------------*
  API
 *---------------------------------------------------------------------------*/
BOOL i_nandEraseBlock( u16 physical_blk);
BOOL i_nandReadPage( NandPageFormat* dest, u32 physical_page_addr, BOOL sync);
BOOL i_nandWritePage( NandPageFormat* src, u32 physical_page_addr, BOOL sync);


#ifdef __cplusplus
}    /* extern "C" */
#endif


#endif    /*__NAND_IF_IP_H__*/
