/*---------------------------------------------------------------------------*
  Project:  CtrBrom - libraries - OS
  File:     os_init.c

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#include <brom/os.h>

//#define BROM_DEBUG_ITCM
//#define FIRM_ENABLE_JTAG_AT_INIT


/*---------------------------------------------------------------------------*
  Name:         osInitBROM

  Description:  initialize sdk os for bootrom

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
void osInitBROM(void)
{
    static BOOL isInit;

    if ( isInit == FALSE )
    {
        isInit = TRUE;

#ifdef SDK_ARM9

#ifdef BROM_DEBUG_ITCM
        MI_CpuFillFast( (void*)HW_ITCM, 0, HW_ITCM_SIZE );
#endif // BROM_DEBUG_ITCM

#endif // SDK_ARM9

        //---- Init Timer
        osInitTimer();

        //---- Init Interrupt
        osInitInterrupt();

        //---- Init Tick
        osInitTick();
    }
}

/*---------------------------------------------------------------------------*
  Name:         osInit

  Description:  initialize sdk os

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
void osInit(void)
{
#ifdef SDK_ARM7

    // Enable JTAG
#ifdef FIRM_ENABLE_JTAG_AT_INIT
    OSi_EnableCpuJTAG();
#endif // FIRM_ENABLE_JTAG_AT_INIT

#endif // SDK_ARM7

    //---- Init Exception System
//    osInitException();

    //---- Init Interrupt
    osInitInterrupt();
}

