/*---------------------------------------------------------------------------*
  Project:  CtrBrom - HW - include
  File:     mmap_main.h

  Copyright 2009 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::           $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_HW_ARM11_MMAP_MAIN_H_
#define BROM_HW_ARM11_MMAP_MAIN_H_

#ifdef __cplusplus
extern "C" {
#endif

// for OS

//------------------------------------- HW_APP_STACK
#define HW_APP_STACK                    (HW_APP_STACK_END - HW_APP_STACK_SIZE)
#define HW_APP_STACK_END                HW_APP_MMU_TBL
#define HW_APP_STACK_SIZE               0x4000  // 16KB

#define HW_APP_SVC_STACK                (HW_APP_SVC_STACK_END - HW_APP_SVC_STACK_SIZE)
#define HW_APP_SVC_STACK_END            HW_APP_STACK_END
#define HW_APP_SVC_STACK_SIZE           0x100  // 256B

#define HW_APP_IRQ_STACK                (HW_APP_IRQ_STACK_END - HW_APP_IRQ_STACK_SIZE)
#define HW_APP_IRQ_STACK_END            HW_APP_SVC_STACK
#define HW_APP_IRQ_STACK_SIZE           (0x1000 - HW_APP_SVC_STACK_SIZE)  // 4KB - 256B

#define HW_APP_SYS_STACK                (HW_APP_SYS_STACK_END - HW_APP_SYS_STACK_SIZE)
#define HW_APP_SYS_STACK_END            HW_APP_IRQ_STACK
#define HW_APP_SYS_STACK_SIZE           (HW_APP_STACK_SIZE - HW_APP_IRQ_STACK_SIZE - HW_APP_SVC_STACK_SIZE)  // 12KB

//------------------------------------- HW_APP_MMU_TBL
#define HW_APP_MMU_TBL                  (HW_APP_MMU_TBL_END - HW_APP_MMU_TBL_SIZE)
#define HW_APP_MMU_TBL_END              HW_MAIN_MEM_END
#define HW_APP_MMU_TBL_SIZE             (HW_APP_MMU_T1_SIZE + HW_APP_MMU_T2_SIZE)  // 32KB

#define HW_APP_MMU_T1                   HW_APP_MMU_TBL
#define HW_APP_MMU_T2                   HW_APP_MMU_T1_END
#define HW_APP_MMU_T1_END               (HW_APP_MMU_T1 + HW_APP_MMU_T1_SIZE)
#define HW_APP_MMU_T2_END               (HW_APP_MMU_T2 + HW_APP_MMU_T2_SIZE)
#define HW_APP_MMU_T1_SIZE              0x4000  // 16KB
#define HW_APP_MMU_T2_SIZE              0x4000  // 16KB


#ifdef __cplusplus
} /* extern "C" */
#endif
/* BROM_HW_ARM11_MMAP_MAIN_H_ */
#endif
