/*---------------------------------------------------------------------------*
  Project:  CtrBrom - HW - include
  File:     mmap_tcm.h

  Copyright 2009 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::           $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_APP_HW_ARM9_MMAP_TCM_H_
#define BROM_APP_HW_ARM9_MMAP_TCM_H_


#ifdef __cplusplus
extern "C" {
#endif

// DTCM

//------------------------------------- HW_APP_STACK
#define HW_APP_STACK                   (HW_APP_STACK_END - HW_APP_STACK_SIZE)
#define HW_APP_STACK_END               HW_DTCM_END
#define HW_APP_STACK_SIZE              0x1000  // 4KB

#define HW_APP_SVC_STACK               (HW_APP_SVC_STACK_END - HW_APP_SVC_STACK_SIZE)
#define HW_APP_SVC_STACK_END           HW_APP_STACK_END
#define HW_APP_SVC_STACK_SIZE          0x100  // 256B

#define HW_APP_IRQ_STACK               (HW_APP_IRQ_STACK_END - HW_APP_IRQ_STACK_SIZE)
#define HW_APP_IRQ_STACK_END           HW_APP_SVC_STACK
#define HW_APP_IRQ_STACK_SIZE          0x400  // 1KB

#define HW_APP_SYS_STACK               (HW_APP_SYS_STACK_END - HW_APP_SYS_STACK_SIZE)
#define HW_APP_SYS_STACK_END           HW_APP_IRQ_STACK
#define HW_APP_SYS_STACK_SIZE          (HW_APP_STACK_SIZE - HW_APP_IRQ_STACK_SIZE - HW_APP_SVC_STACK_SIZE)  // 2.75KB

// ITCM

// no reserved

#ifdef __cplusplus
} /* extern "C" */
#endif
/* BROM_APP_HW_ARM9_MMAP_TCM_H_ */
#endif
