/*---------------------------------------------------------------------------*
  Project:  CtrBrom - HW - include
  File:     mmap_brom.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::           $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_HW_ARM11_MMAP_BROM_H_
#define BROM_HW_ARM11_MMAP_BROM_H_

#include <brom/brom_defs.h>
#include <ctr/hw/ARM11/mmap_global.h>
#include <firm/hw/ARM11/mmap_firm.h>
#include <brom/hw/ARM11/mmap_axi_wram.h>
#include <brom/hw/common/mmap_shared.h>

#ifdef __cplusplus
extern "C" {
#endif

//------------------------------------- BROM
#define HW_BROM_IMG                     HW_BIOS_IMG
#define HW_BROM                         HW_BIOS
#define HW_BROM_END                     (HW_BROM + HW_BROM_SIZE)
#define HW_BROM_SIZE                    0x10000 // 64KB

#define HW_BROM_NML                     HW_BROM
#define HW_BROM_NML_END                 (HW_BROM_NML + HW_BROM_NML_SIZE)
#define HW_BROM_NML_SIZE                0x8000  // 32KB
#define HW_BROM_NML_ABT                 HW_BROM_NML
#define HW_BROM_NML_ABT_END             (HW_BROM_NML_ABT + HW_BROM_NML_ABT_SIZE)
#define HW_BROM_NML_ABT_SIZE            0x1000  // 4KB
#define HW_BROM_SEC                     HW_BROM_NML_END
#define HW_BROM_SEC_END                 (HW_BROM_SEC + HW_BROM_SEC_SIZE)
#define HW_BROM_SEC_SIZE                HW_BROM_NML_SIZE


#ifdef __cplusplus
} /* extern "C" */
#endif
/* BROM_HW_ARM11_MMAP_BROM_H_ */
#endif
