/*---------------------------------------------------------------------------*
  Project:  CtrBrom - HW - include
  File:     mmap_brom.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_HW_ARM9_MMAP_BROM_H_
#define BROM_HW_ARM9_MMAP_BROM_H_

#include <brom/brom_defs.h>
#include <ctr/hw/ARM9/mmap_global.h>
#include <firm/hw/ARM9/mmap_firm.h>
#include <brom/hw/ARM9/mmap_tcm.h>
#include <brom/hw/common/mmap_shared.h>

#ifdef __cplusplus
extern "C" {
#endif

//------------------------------------- BROM
#ifdef BROM_ENABLE_WRAMEMU
#define HW_BROM                         HW_WRAM
#else // BROM_ENABLE_WRAMEMU
#define HW_BROM                         HW_BIOS
#endif
#define HW_BROM_END                     (HW_BROM + HW_BROM_SIZE)
#ifdef SDK_MG20EMU
#define HW_BROM_SIZE                    0x8000  // 32KB
#else // SDK_MG20EMU
#define HW_BROM_SIZE                    0x10000 // 64KB
#endif // SDK_MG20EMU

#define HW_BROM_NML                     HW_BROM
#define HW_BROM_NML_END                 (HW_BROM_NML + HW_BROM_NML_SIZE)
#ifdef SDK_MG20EMU
#define HW_BROM_NML_SIZE                0x4000  // 16KB
#else // SDK_MG20EMU
#define HW_BROM_NML_SIZE                0x8000  // 32KB
#endif // SDK_MG20EMU
#define HW_BROM_SEC                     HW_BROM_NML_END
#define HW_BROM_SEC_END                 (HW_BROM_SEC + HW_BROM_SEC_SIZE)
#define HW_BROM_SEC_SIZE                HW_BROM_NML_SIZE


#ifdef __cplusplus
} /* extern "C" */
#endif
/* BROM_HW_ARM9_MMAP_BROM_H_ */
#endif
