/*---------------------------------------------------------------------------*
  Project:  CtrBrom - HW - include
  File:     mmap_tcm.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::           $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_HW_ARM9_MMAP_TCM_H_
#define BROM_HW_ARM9_MMAP_TCM_H_


#ifdef __cplusplus
extern "C" {
#endif

// DTCM

//------------------------------------- HW_BROM_WRAM
#define HW_BROM_WRAM                    HW_DTCM
#define HW_BROM_WRAM_END                (HW_BROM_WRAM + HW_BROM_WRAM_SIZE)
#define HW_BROM_WRAM_SIZE               (HW_DTCM_SIZE - HW_BROM_STACK_SIZE)

//------------------------------------- HW_BROM_STACK
#define HW_BROM_STACK                   (HW_BROM_STACK_END - HW_BROM_STACK_SIZE)
#define HW_BROM_STACK_END               HW_DTCM_END
#define HW_BROM_STACK_SIZE              0x1000  // 4KB

#define HW_BROM_SVC_STACK               (HW_BROM_SVC_STACK_END - HW_BROM_SVC_STACK_SIZE)
#define HW_BROM_SVC_STACK_END           HW_BROM_STACK_END
#define HW_BROM_SVC_STACK_SIZE          0x100  // 256B

#define HW_BROM_IRQ_STACK               (HW_BROM_IRQ_STACK_END - HW_BROM_IRQ_STACK_SIZE)
#define HW_BROM_IRQ_STACK_END           HW_BROM_SVC_STACK
#define HW_BROM_IRQ_STACK_SIZE          0x400  // 1KB

#define HW_BROM_SYS_STACK               (HW_BROM_SYS_STACK_END - HW_BROM_SYS_STACK_SIZE)
#define HW_BROM_SYS_STACK_END           HW_BROM_IRQ_STACK
#define HW_BROM_SYS_STACK_SIZE          (HW_BROM_STACK_SIZE - HW_BROM_IRQ_STACK_SIZE - HW_BROM_SVC_STACK_SIZE)  // 2.75KB

// ITCM

//------------------------------------- HW_BROM_CACHE_DEBUG_BUF
#define HW_BROM_CACHE_DEBUG_BUF         HW_FIRM_CACHE_DEBUG_BUF  // defined in mmap_firm.h
#define HW_BROM_CACHE_DEBUG_BUF_END     HW_FIRM_CACHE_DEBUG_BUF_END
#define HW_BROM_CACHE_DEBUG_BUF_SIZE    HW_FIRM_CACHE_DEBUG_BUF_SIZE  // 13.5KB

//------------------------------------- HW_BROM_TO_FIRM_BUF
#define HW_BROM_TO_FIRM_BUF             HW_FIRM_FROM_BROM_BUF  // defined in mmap_firm.h
#define HW_BROM_TO_FIRM_BUF_END         HW_FIRM_FROM_BROM_BUF_END
#define HW_BROM_TO_FIRM_BUF_SIZE        HW_FIRM_FROM_BROM_BUF_SIZE  // 12KB


#ifdef __cplusplus
} /* extern "C" */
#endif
/* BROM_HW_ARM9_MMAP_TCM_H_ */
#endif
