/*---------------------------------------------------------------------------*
  Project:  TwlBrom - init - include
  File:     stup.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_INIT_STUP_H_
#define BROM_INIT_STUP_H_

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------*
  Name:         stupInitExcptions

  Description:  Initialize Excptions

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
void stupInitExcptions( void );

#ifdef SDK_ARM11
#ifdef SDK_NE1ENU
void i_stupInitDDR2( void );
#endif // SDK_NE1ENU
void    i_stupPostMappingWram( void );
void    i_stupNotifyToARM9( u32 id );
void    i_stupWaitARM9( u32 id );

#else //  SDK_ARM9
void    i_stupWaitSecureRomMask( void );
void    i_stupPostMappingWram( void );
void    i_stupNotifyToARM7( u32 id );
void    i_stupWaitARM7( u32 id );

#endif //  SDK_ARM9

#ifdef __cplusplus
} /* extern "C" */
#endif

/* BROM_INIT_CRT0_H_ */
#endif
