/*---------------------------------------------------------------------------*
  Project:  CtrBrom - MI - include
  File:     byteAccess.h

  Copyright 2003-2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/

#ifndef BROM_MI_BYTEACCESS_H_
#define BROM_MI_BYTEACCESS_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <brom/types.h>

/*---------------------------------------------------------------------------*
  Name:         miReadByte

  Description:  read bytedata

  Arguments:    address : address to read bytedata

  Returns:      byte data
 *---------------------------------------------------------------------------*/
static inline u8 miReadByte(const void *address)
{
    return *(u8 *)address;
}


/*---------------------------------------------------------------------------*
  Name:         miWriteByte

  Description:  write bytedata

  Arguments:    address : address to write bytedata

  Returns:      None.
 *---------------------------------------------------------------------------*/
static inline void miWriteByte(void *address, u8 value)
{
    *(u8 *)address = value;
}

#ifdef __cplusplus
} /* extern "C" */
#endif

/* BROM_MI_BYTEACCESS_H_ */
#endif
