/*---------------------------------------------------------------------------*
  Project:  CtrBrom - OS
  File:     os.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_OS_H_
#define BROM_OS_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <brom/types.h>
#include <brom/memorymap.h>
#include <ctr/arm_reg.h>
#include <ctr/os/common/svc.h>

#include <brom/init/crt0.h>
#include <brom/math.h>
#include <brom/mi.h>
#include <brom/os/common/system.h>
#include <brom/os/common/init.h>
#include <brom/os/common/tick.h>
#include <brom/os/common/alarm.h>
#include <brom/os/common/mutex.h>
#include <brom/os/common/message.h>
#include <brom/os/common/thread.h>
#include <brom/os/common/timer.h>
#include <brom/os/common/interrupt.h>
#include <brom/os/common/exception.h>
#include <brom/os/common/cache.h>
#include <brom/os/common/printf.h>
#include <brom/os/common/spinLock.h>
#include <brom/os/common/boot.h>
#include <brom/os/common/event.h>

#ifdef SDK_ARM11
#include <brom/os/ARM11/mmu.h>
#else // SDK_ARM9
#include <brom/os/ARM9/protectionUnit.h>
#endif // SDK_ARM9

#if 0
#include <brom/os/common/systemWork.h>
#include <brom/os/common/systemCall.h>

#ifdef SDK_ARM9
#include <brom/os/ARM9/protectionUnit.h>
#include <brom/os/ARM9/protectionRegion.h>
#include <brom/os/ARM9/tcm.h>
#endif // SDK_ARM9
#endif

#ifdef SDK_DEBUGGER_KMC
#include <brom/vlink.h>
#endif // SDK_DEBUGGER_KMC

#ifdef __cplusplus
} /* extern "C" */
#endif

/* BROM_OS_H_ */
#endif
