/*---------------------------------------------------------------------------*
  Project:  CtrBrom - OS - include
  File:     interrupt_types.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_OS_INTERRUPT_TYPES_H_
#define BROM_OS_INTERRUPT_TYPES_H_

#include <ctr/arm_reg.h>
#include <ctr/ioreg.h>

#ifdef __cplusplus
extern "C" {
#endif


typedef u32 OSIntrMask;

typedef enum
{
    OS_INTR_ID_DMA0 = REG_OS_IE_D0_SHIFT,
    OS_INTR_ID_DMA1 = REG_OS_IE_D1_SHIFT,
    OS_INTR_ID_DMA2 = REG_OS_IE_D2_SHIFT,
    OS_INTR_ID_DMA3 = REG_OS_IE_D3_SHIFT,
    OS_INTR_ID_TIMER0 = REG_OS_IE_T0_SHIFT,
    OS_INTR_ID_TIMER1 = REG_OS_IE_T1_SHIFT,
    OS_INTR_ID_TIMER2 = REG_OS_IE_T2_SHIFT,
    OS_INTR_ID_TIMER3 = REG_OS_IE_T3_SHIFT,

    OS_INTR_ID_NUM
}
OSIntrID;


//----------------------------------------------------------------------
//                  IE/IF flags
//----------------------------------------------------------------------
#define OS_IE_DMA0          (1UL << REG_OS_IE_D0_SHIFT) // DMA0
#define OS_IE_DMA1          (1UL << REG_OS_IE_D1_SHIFT) // DMA1
#define OS_IE_DMA2          (1UL << REG_OS_IE_D2_SHIFT) // DMA2
#define OS_IE_DMA3          (1UL << REG_OS_IE_D3_SHIFT) // DMA3
#define OS_IE_TIMER0        (1UL << REG_OS_IE_T0_SHIFT) // timer0
#define OS_IE_TIMER1        (1UL << REG_OS_IE_T1_SHIFT) // timer1
#define OS_IE_TIMER2        (1UL << REG_OS_IE_T2_SHIFT) // timer2
#define OS_IE_TIMER3        (1UL << REG_OS_IE_T3_SHIFT) // timer3


#ifdef __cplusplus
} // extern "C"
#endif

#endif // BROM_OS_INTERRUPT_TYPES_H_
