/*---------------------------------------------------------------------------*
  Project:  CtrBrom - OS - include
  File:     protectionUnit.h

  Copyright 2009 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_OS_PROTECTIONUNIT_H_
#define BROM_OS_PROTECTIONUNIT_H_

#include <brom/misc.h>
#include <brom/types.h>

#ifdef __cplusplus
extern "C" {
#endif

//======================================================================
//          protection unit
//======================================================================
/*---------------------------------------------------------------------------*
  Name:         osEnableProtectionUnit

  Description:  enable protection unit

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
void    osEnableProtectionUnit(void);

/*---------------------------------------------------------------------------*
  Name:         osDisableProtectionUnit

  Description:  disable protection unit

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
void    osDisableProtectionUnit(void);

/*---------------------------------------------------------------------------*
  Name:         i_osFinalizeProtectionUnit

  Description:  finalize protection unit

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
void    i_osFinalizeProtectionUnit( void );

#ifdef __cplusplus
} /* extern "C" */
#endif

/* BROM_OS_PROTECTIONUNIT_H_ */
#endif
