/*---------------------------------------------------------------------------*
  Project:  CtrBrom - OS - include
  File:     boot.h

  Copyright 2009 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_OS_BOOT_H_
#define BROM_OS_BOOT_H_

#include <brom/misc.h>
#include <brom/types.h>
#include <brom/memorymap.h>

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------*
  Name:         i_osFinalize

  Description:  finalize

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
void i_osFinalize(void);

/*---------------------------------------------------------------------------*
  Name:         i_osClearWorkArea

  Description:  clear work area

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
void i_osClearWorkArea( void );

#ifdef __cplusplus
} /* extern "C" */
#endif

/* BROM_OS_BOOT_H_ */
#endif
