/*---------------------------------------------------------------------------*
  Project:  CtrBrom - OS - include
  File:     exception.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_OS_EXCEPTION_H_
#define BROM_OS_EXCEPTION_H_

#include <brom/types.h>
#include <brom/memorymap.h>
#include <ctr/ioreg.h>

#ifdef __cplusplus
extern "C" {
#endif

//---- exception handler type
typedef void (*OSExcpHandler) (void);


/*---------------------------------------------------------------------------*
  Name:         osInitException

  Description:  Initialize Exceptions for Application

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
void osInitException( void );


#ifdef __cplusplus
} /* extern "C" */
#endif

/* BROM_OS_EXCEPTION_H_ */
#endif
