/*---------------------------------------------------------------------------*
  Project:  CtrBrom - OS - include
  File:     init.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_OS_INIT_H_
#define BROM_OS_INIT_H_

#include <brom/misc.h>
#include <brom/types.h>

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------*
  Name:         osInitBROM

  Description:  initialize sdk os for bootrom

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
void osInitBROM(void);

/*---------------------------------------------------------------------------*
  Name:         osInit

  Description:  initialize sdk os

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
void osInit(void);



#ifdef __cplusplus
} /* extern "C" */
#endif

/* BROM_OS_INIT_H_ */
#endif
