/*---------------------------------------------------------------------------*
  Project:  CtrBrom - include - PXI
  File:     regname.h

  Copyright 2009 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_PXI_COMMON_REGNAME_H_
#define BROM_PXI_COMMON_REGNAME_H_

#include <brom/types.h>

#ifdef __cplusplus
extern "C" {
#endif

// Register rename
typedef enum
{
    PXI_PROC_ARM11 = 0,
    PXI_PROC_ARM9  = 1
}
PXIProc;

#ifdef	SDK_ARM11

#define	PXI_PROC_ARM                     PXI_PROC_ARM11

#define reg_PXI_FIFO_CNT                 reg_PXI_SUBP_FIFO_CNT
#define REG_PXI_FIFO_CNT_ERR_MASK        REG_PXI_SUBP_FIFO_CNT_ERR_MASK
#define REG_PXI_FIFO_CNT_SEND_CL_MASK    REG_PXI_SUBP_FIFO_CNT_SEND_CL_MASK
#define REG_PXI_FIFO_CNT_SEND_FULL_MASK  REG_PXI_SUBP_FIFO_CNT_SEND_FULL_MASK
#define REG_PXI_FIFO_CNT_SEND_FULL_SHIFT REG_PXI_SUBP_FIFO_CNT_SEND_FULL_SHIFT
#define REG_PXI_FIFO_CNT_SEND_TI_MASK    REG_PXI_SUBP_FIFO_CNT_SEND_TI_MASK
#define REG_PXI_FIFO_CNT_RECV_RI_MASK    REG_PXI_SUBP_FIFO_CNT_RECV_RI_MASK
#define REG_PXI_FIFO_CNT_RECV_EMP_MASK   REG_PXI_SUBP_FIFO_CNT_RECV_EMP_MASK
#define REG_PXI_FIFO_CNT_RECV_EMP_SHIFT  REG_PXI_SUBP_FIFO_CNT_RECV_EMP_SHIFT
#define REG_PXI_FIFO_CNT_E_MASK          REG_PXI_SUBP_FIFO_CNT_E_MASK

#define reg_PXI_INTF                     reg_PXI_SUBPINTF
#define	REG_PXI_INTF_I_MASK              REG_PXI_SUBPINTF_I_MASK
#define REG_PXI_INTF_IREQ_MASK           REG_PXI_SUBPINTF_IREQ_MASK
#define	REG_PXI_INTF_SEND_MASK           REG_PXI_SUBPINTF_A11STATUS_MASK
#define	REG_PXI_INTF_SEND_SHIFT          REG_PXI_SUBPINTF_A11STATUS_SHIFT
#define	REG_PXI_INTF_RECV_MASK           REG_PXI_SUBPINTF_A9STATUS_MASK
#define	REG_PXI_INTF_RECV_SHIFT          REG_PXI_SUBPINTF_A9STATUS_SHIFT

#else  // SDK_ARM9

#define	PXI_PROC_ARM                     PXI_PROC_ARM9

#define reg_PXI_FIFO_CNT                 reg_PXI_MAINP_FIFO_CNT
#define REG_PXI_FIFO_CNT_ERR_MASK        REG_PXI_MAINP_FIFO_CNT_ERR_MASK
#define REG_PXI_FIFO_CNT_SEND_CL_MASK    REG_PXI_MAINP_FIFO_CNT_SEND_CL_MASK
#define REG_PXI_FIFO_CNT_SEND_FULL_MASK  REG_PXI_MAINP_FIFO_CNT_SEND_FULL_MASK
#define REG_PXI_FIFO_CNT_SEND_FULL_SHIFT REG_PXI_MAINP_FIFO_CNT_SEND_FULL_SHIFT
#define REG_PXI_FIFO_CNT_SEND_TI_MASK    REG_PXI_MAINP_FIFO_CNT_SEND_TI_MASK
#define REG_PXI_FIFO_CNT_RECV_RI_MASK    REG_PXI_MAINP_FIFO_CNT_RECV_RI_MASK
#define REG_PXI_FIFO_CNT_RECV_EMP_MASK   REG_PXI_MAINP_FIFO_CNT_RECV_EMP_MASK
#define REG_PXI_FIFO_CNT_RECV_EMP_SHIFT  REG_PXI_MAINP_FIFO_CNT_RECV_EMP_SHIFT
#define REG_PXI_FIFO_CNT_E_MASK          REG_PXI_MAINP_FIFO_CNT_E_MASK

#define reg_PXI_INTF                     reg_PXI_MAINPINTF
#define	REG_PXI_INTF_I_MASK              REG_PXI_MAINPINTF_I_MASK
#define REG_PXI_INTF_IREQ_MASK           REG_PXI_MAINPINTF_IREQ_MASK
#define	REG_PXI_INTF_SEND_MASK           REG_PXI_MAINPINTF_A9STATUS_MASK
#define	REG_PXI_INTF_SEND_SHIFT          REG_PXI_MAINPINTF_A9STATUS_SHIFT
#define	REG_PXI_INTF_RECV_MASK           REG_PXI_MAINPINTF_A11STATUS_MASK
#define	REG_PXI_INTF_RECV_SHIFT          REG_PXI_MAINPINTF_A11STATUS_SHIFT

#endif

#ifdef __cplusplus
} /* extern "C" */
#endif
/* BROM_PXI_COMMON_REGNAME_H_ */
#endif
