/*---------------------------------------------------------------------------*
  Project:  TWL - SD driver
  File:     sdmc.h

  Copyright 2006-2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
  
  $Date:: #$
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/

#ifndef __SDMC_H__
#define __SDMC_H__

#include <rtfs.h>


#ifdef __cplusplus
extern "C" {
#endif



/*********************************************
 SDXybN\
*********************************************/
typedef struct {
    u32     csd_ver2_flag;              //CSDtH[}bgo[W(SDHĈƂ1)
    u32     memory_capacity;            //data areãTCY(512ByteP)
    u32     protected_capacity;         //protected areãTCY(512ByteP)
    u32     card_capacity;              //J[hŜ̃TCY(512ByteP)

    u32     adjusted_memory_capacity;   //memory_capacityV_(heads*secptrack)̔{ɒTCY(cylinders*heads*secptrackɂȂ)

    u16     heads;
    u16     secptrack;
    u16     cylinders;
    u16     SC;                         //sectors per cluster
    u16     BU;
    u16     RDE;                        //number of root dir entries(512 fix)
    u32     SS;                         //sector size(512 fix)
    u32     RSC;                        //reserved sector count(1 fix)
//    u32     TS;                         //total sectors
    u16     FATBITS;                    //16 or 32
    u16     SF;                         //sectors per FAT
    u32     SSA;                        //sectors in system area
    u32     NOM;                        //sectors in master boot record
} SdmcSpec;


/*FATp[^ TODO:SdmcSpec𓝍邱*/
typedef struct {
    u32    device_capacity;          //foCXŜ̃TCY(512ByteP)
    u32    adjusted_device_capacity;

    u32    memory_capacity;          //data areãTCY(512ByteP)
    u32    adjusted_memory_capacity; //memory_capacityV_(heads*secptrack)̔{ɒTCY(cylinders*heads*secptrackɂȂ)

    u16    volume_cylinders;

    u16    heads;
    u16    secptrack;
    u16    cylinders;
    u16    SC;                       //sectors per cluster
    u16    BU;
    u16    RDE;                      //number of root dir entries(512 fix)
    u16    padding;
    u32    SS;                       //sector size(512 fix)
    u32    RSC;                      //reserved sector count(1 fix)
    u16    FATBITS;                  //16 or 32
    u16    SF;                       //sectors per FAT
    u32    SSA;                      //sectors in system area
    u32    NOM;                      //sectors in master boot record

    u32    begin_sect;
} FATSpec;



#ifdef __cplusplus
}    /* extern "C" */
#endif


#endif /*__SDMC_H__*/
