#include <rtfs.h>

/* To preserve memory you may exclude strings from the string table
   if the corresponding module is not being used. Set the definition
   in this table to zero if you wish to exclude strings from the
   from the corresponding module.
*/

/*---------- twl modified ----------*/
#include <rtfsconf.h>
#define INCLUDE_WINSPLSH_STRINGS    RTFS_DEBUG_PRINT_ON
#define INCLUDE_CRITERR_STRINGS     RTFS_DEBUG_PRINT_ON
#define INCLUDE_REGRESS_STRINGS     RTFS_DEBUG_PRINT_ON
/*----------------------------------*/
#define INCLUDE_CHKDSK_STRINGS      RTFS_DEBUG_PRINT_ON /* twl modified 1 -> RTFS_DEBUG_PRINT_ON */
#define INCLUDE_FLDRVER_STRINGS     0 /* twl modified 1 -> 0 */
#define INCLUDE_FLASHDRV_STRINGS    0 /* twl modified 1 -> 0 */
#define INCLUDE_FLASHEMU_STRINGS    0 /* twl modified 1 -> 0 */
#define INCLUDE_RTFSINIT_STRINGS    RTFS_DEBUG_PRINT_ON /* twl modified 1 -> RTFS_DEBUG_PRINT_ON */
#define INCLUDE_IDEDRV_STRINGS      0 /* twl modified 1 -> 0 */
#define INCLUDE_PORTMAIN_STRINGS    0 /* twl modified 1 -> 0 */
#define INCLUDE_PORTKERN_STRINGS    RTFS_DEBUG_PRINT_ON /* twl modified 1 -> RTFS_DEBUG_PRINT_ON */
#define INCLUDE_RTFSDEM_STRINGS     RTFS_DEBUG_PRINT_ON /* For APIRGRS.C */ /* twl modified 1 -> RTFS_DEBUG_PRINT_ON */
#define INCLUDE_TSTSH_STRINGS       RTFS_DEBUG_PRINT_ON /* twl modified 1 -> RTFS_DEBUG_PRINT_ON */


/* Set this value to 1 if strings are entered as ascii and we require
   the unicode layer to expand them to 16 bit character strings
   set it to zero if you replace the strrings in the table with
   true UNICODE
*/
typedef struct rtfs_string_table {
    int string_id;
    byte *string_value;
} RTFS_STRING_TABLE;

KS_CONSTANT RTFS_STRING_TABLE prompt_table[] = {
#if (INCLUDE_CS_UNICODE)
    {UPROMPT_CRITERR,(byte *)L"Type A to abort R to Retry"},
    {UPROMPT_REGRESS,(byte *)L"Regression Test Error, press any key to exit" },
#else
    {UPROMPT_CRITERR,(byte *)"Type A to abort R to Retry"},
    {UPROMPT_REGRESS,(byte *)"Regression Test Error, press any key to exit" },
#endif
#if (INCLUDE_TSTSH_STRINGS)
#if (INCLUDE_CS_UNICODE)
    {UPROMPT_TSTSH1,(byte *)L"CMD> " },
    {UPROMPT_TSTSH2,(byte *)L"Press Return " },
    {UPROMPT_TSTSH3,(byte *)L"Enter the drive to format as A:, B: etc " },
    {UPROMPT_TSTSH4,(byte *)L"Invalid drive selection to format, press return" },
    {UPROMPT_TSTSH5,(byte *)L"Format - check media failed. Press return" },
    {UPROMPT_TSTSH6,(byte *)L"Format: get media geometry failed. Press return" },
    {UPROMPT_TSTSH7,(byte *)L"Format: Press Y to format media " },
    {UPROMPT_TSTSH8,(byte *)L"Format: Media format failed. Press return" },
    {UPROMPT_TSTSH9,(byte *)L"Format: Press Y to partition media " },
    {UPROMPT_TSTSH10,(byte *)L"Format: Press Y to USE LBA formatting, N to use CHS " },
    {UPROMPT_TSTSH11,(byte *)L"Format: Select the number of lbas for the first partition :" },
    {UPROMPT_TSTSH12,(byte *)L"Format: Select the number of lbas for the second partition :" },
    {UPROMPT_TSTSH13,(byte *)L"Format: Bad input for partition values. Press return" },
    {UPROMPT_TSTSH14,(byte *)L"Format: Select the number of cyls for the first partition :" },
    {UPROMPT_TSTSH15,(byte *)L"Format: Select the number of cyls for the second partition :" },
    {UPROMPT_TSTSH16,(byte *)L"Format: Media partition failed. Press return" },
    {UPROMPT_TSTSH17,(byte *)L"Format: Press Y to format the volume " },
    {UPROMPT_TSTSH18,(byte *)L"Format: Format volume failed. Press return" },
#else
    {UPROMPT_TSTSH1,(byte *)"CMD> " },
    {UPROMPT_TSTSH2,(byte *)"Press Return " },
    {UPROMPT_TSTSH3,(byte *)"Enter the drive to format as A:, B: etc " },
    {UPROMPT_TSTSH4,(byte *)"Invalid drive selection to format, press return" },
    {UPROMPT_TSTSH5,(byte *)"Format - check media failed. Press return" },
    {UPROMPT_TSTSH6,(byte *)"Format: get media geometry failed. Press return" },
    {UPROMPT_TSTSH7,(byte *)"Format: Press Y to format media " },
    {UPROMPT_TSTSH8,(byte *)"Format: Media format failed. Press return" },
    {UPROMPT_TSTSH9,(byte *)"Format: Press Y to partition media " },
    {UPROMPT_TSTSH10,(byte *)"Format: Press Y to USE LBA formatting, N to use CHS " },
    {UPROMPT_TSTSH11,(byte *)"Format: Select the number of lbas for the first partition :" },
    {UPROMPT_TSTSH12,(byte *)"Format: Select the number of lbas for the second partition :" },
    {UPROMPT_TSTSH13,(byte *)"Format: Bad input for partition values. Press return" },
    {UPROMPT_TSTSH14,(byte *)"Format: Select the number of cyls for the first partition :" },
    {UPROMPT_TSTSH15,(byte *)"Format: Select the number of cyls for the second partition :" },
    {UPROMPT_TSTSH16,(byte *)"Format: Media partition failed. Press return" },
    {UPROMPT_TSTSH17,(byte *)"Format: Press Y to format the volume " },
    {UPROMPT_TSTSH18,(byte *)"Format: Format volume failed. Press return" },
#endif
#endif /* (INCLUDE_TSTSH_STRINGS) */
#if (INCLUDE_CS_UNICODE)
    {UPROMPT_WINSPLSH,(byte *)L"<return> for next,  (P)<return> for Previous, (Q)<return> to run demo" },
    {0,(byte *)L"Unkown User Prompt" }
#else
    {UPROMPT_WINSPLSH,(byte *)"<return> for next,  (P)<return> for Previous, (Q)<return> to run demo" },
    {0,(byte *)"Unkown User Prompt" }
#endif
    };

KS_CONSTANT RTFS_STRING_TABLE string_table[] = {
#if (INCLUDE_CS_UNICODE)
    {USTRING_SYS_NULL,(byte *)L"" },
/* Note that USTRING_SYS_BADALIAS is not stored as a wide string. this
   is processed as a string of 8 bit characters */
    {USTRING_SYS_BADALIAS,(byte *)"\\/:*?\"<>| ,;=+[]" },
    {USTRING_SYS_BADLFN,(byte *)L"\\/:*?\"<>|" },
/* Note that USTRING_SYS_UCRESERVED_NAMES and  USTRING_SYS_LCRESERVED_NAMES
   are not stored as a wide string. they are processed as strings of 8 bit characters */
    {USTRING_SYS_UCRESERVED_NAMES,(byte *)"CON,PRN,NUL,AUX,LPT1,LPT2,LPT3,LPT4,COM1,COM2,COM3,COM4" },
    {USTRING_SYS_LCRESERVED_NAMES,(byte *)"con,prn,nul,aux,lpt1,lpt2,lpt3,lpt4,com1,com2,com3,com4" },
    {USTRING_SYS_VOLUME_LABEL,(byte *)L"VOLUMELABEL" },  /* 11 chars max (12th is NUL) */
    {USTRING_SYS_OEMNAME,(byte *)L"EBS" },
    {USTRING_SYS_TAB,(byte *)L"       " },
#if (INCLUDE_FAILSAFE_CODE)
    {USTRING_SYS_FSFILENAME,(byte *)L"\\FAILSAFE" },
#endif
#else
    {USTRING_SYS_NULL,(byte *)"" },
    {USTRING_SYS_BADALIAS,(byte *)"\\/:*?\"<>| ,;=+[]" },
    {USTRING_SYS_BADLFN,(byte *)"\\/:*?\"<>|" },
    {USTRING_SYS_UCRESERVED_NAMES,(byte *)"CON,PRN,NUL,AUX,LPT1,LPT2,LPT3,LPT4,COM1,COM2,COM3,COM4" },
    {USTRING_SYS_LCRESERVED_NAMES,(byte *)"con,prn,nul,aux,lpt1,lpt2,lpt3,lpt4,com1,com2,com3,com4" },
    {USTRING_SYS_VOLUME_LABEL,(byte *)"VOLUMELABE" },  /* 11 chars max (12th is NUL) */
    {USTRING_SYS_OEMNAME,(byte *)"EBS" },
    {USTRING_SYS_TAB,(byte *)"       " },
#if (INCLUDE_FAILSAFE_CODE)
    {USTRING_SYS_FSFILENAME,(byte *)"\\FAILSAFE" },
#endif
#endif
#if (INCLUDE_CHKDSK_STRINGS)
#if (INCLUDE_CS_UNICODE)
    {USTRING_CHKDSK_01,(byte *)L"Error Accessing: " },
    {USTRING_CHKDSK_02,(byte *)L"Failed Allocating Core To Run" },
    {USTRING_CHKDSK_03,(byte *)L"Failed Scanning Disk Files" },
    {USTRING_CHKDSK_04,(byte *)L"Failed Scanning Fat" },
    {USTRING_CHKDSK_05,(byte *)L"     Creating .CHK Files" },
    {USTRING_CHKDSK_06,(byte *)L"     Failed Creating .CHK Files" },
    {USTRING_CHKDSK_07,(byte *)L"      Use -f option to create .CHK files" },
    {USTRING_CHKDSK_08,(byte *)L"Failed Scanning Crossed Files" },
    {USTRING_CHKDSK_09,(byte *)L"      Crossed Chains Were Found" },
    {USTRING_CHKDSK_11,(byte *)L"       user files in this many directories " },
    {USTRING_CHKDSK_13,(byte *)L"     Kbytes total disk space" },
    {USTRING_CHKDSK_15,(byte *)L" Kbytes in " },
    {USTRING_CHKDSK_16,(byte *)L" hidden files" },
    {USTRING_CHKDSK_18,(byte *)L" KBytes in " },
    {USTRING_CHKDSK_19,(byte *)L" directories" },
    {USTRING_CHKDSK_21,(byte *)L" KBytes in " },
    {USTRING_CHKDSK_22,(byte *)L" user files" },
    {USTRING_CHKDSK_24,(byte *)L" KBytes in bad sectors" },
    {USTRING_CHKDSK_26,(byte *)L" Free sectors available on disk" },
    {USTRING_CHKDSK_29,(byte *)L" Bytes Per Allocation Unit" },
    {USTRING_CHKDSK_30,(byte *)L" " },
    {USTRING_CHKDSK_32,(byte *)L" Total Allocation Units On Disk" },
    {USTRING_CHKDSK_35,(byte *)L" lost clusters found in " },
    {USTRING_CHKDSK_36,(byte *)L" lost chains" },
    {USTRING_CHKDSK_38,(byte *)L"  bad long file name chains found" },
    {USTRING_CHKDSK_39,(byte *)L" and deleted" },
    {USTRING_CHKDSK_40,(byte *)L" that were not deleted" },
    {USTRING_CHKDSK_41,(byte *)L"      Chains Crossed at Cluster" },
    {USTRING_CHKDSK_42,(byte *)L"             " },
    {USTRING_CHKDSK_43,(byte *)L"       Lost Chains" },
    {USTRING_CHKDSK_44,(byte *)L"       A Lost Chain" },
    {USTRING_CHKDSK_45,(byte *)L"Path too deep , directory == " },
    {USTRING_CHKDSK_46,(byte *)L"Failed Scanning This Directory on LFN Pass  -" },
    {USTRING_CHKDSK_47,(byte *)L"Failed Scanning This Directory -" },
    {USTRING_CHKDSK_48,(byte *)L"Failed Scanning This Directory -" },
    {USTRING_CHKDSK_49,(byte *)L"    " },
    {USTRING_CHKDSK_50,(byte *)L"Failed Scanning This File " },
    {USTRING_CHKDSK_51,(byte *)L"Failed Scanning This Directory -" },
    {USTRING_CHKDSK_52,(byte *)L"Failed Writing This Adusted File:    " },
    {USTRING_CHKDSK_53,(byte *)L"Size Adusted, This File:    " },
    {USTRING_CHKDSK_54,(byte *)L"Size Needs Adusting This File:    " },
    {USTRING_CHKDSK_55,(byte *)L"Chkdsk Giving up. Too Many Lost Chains" },
    {USTRING_CHKDSK_56,(byte *)L"Failed Scanning This Directory " },
    {USTRING_CHKDSK_57,(byte *)L"Failed Scanning This Directory " },
    {USTRING_CHKDSK_58,(byte *)L"    " },
    {USTRING_CHKDSK_59,(byte *)L"Failed Scanning This File " },
    {USTRING_CHKDSK_60,(byte *)L"Failed Scanning This Directory " },
    {USTRING_CHKDSK_61,(byte *)L"Chkdsk gives up, too many crossed Files" },
    {USTRING_CHKDSK_62,(byte *)L"Chkdsk gives up, Too many crossed chains" },
#else
    {USTRING_CHKDSK_01,(byte *)"Error Accessing: " },
    {USTRING_CHKDSK_02,(byte *)"Failed Allocating Core To Run" },
    {USTRING_CHKDSK_03,(byte *)"Failed Scanning Disk Files" },
    {USTRING_CHKDSK_04,(byte *)"Failed Scanning Fat" },
    {USTRING_CHKDSK_05,(byte *)"     Creating .CHK Files" },
    {USTRING_CHKDSK_06,(byte *)"     Failed Creating .CHK Files" },
    {USTRING_CHKDSK_07,(byte *)"      Use -f option to create .CHK files" },
    {USTRING_CHKDSK_08,(byte *)"Failed Scanning Crossed Files" },
    {USTRING_CHKDSK_09,(byte *)"      Crossed Chains Were Found" },
    {USTRING_CHKDSK_11,(byte *)"       user files in this many directories " },
    {USTRING_CHKDSK_13,(byte *)"     Kbytes total disk space" },
    {USTRING_CHKDSK_15,(byte *)" Kbytes in " },
    {USTRING_CHKDSK_16,(byte *)" hidden files" },
    {USTRING_CHKDSK_18,(byte *)" KBytes in " },
    {USTRING_CHKDSK_19,(byte *)" directories" },
    {USTRING_CHKDSK_21,(byte *)" KBytes in " },
    {USTRING_CHKDSK_22,(byte *)" user files" },
    {USTRING_CHKDSK_24,(byte *)" KBytes in bad sectors" },
    {USTRING_CHKDSK_26,(byte *)" Free sectors available on disk" },
    {USTRING_CHKDSK_29,(byte *)" Bytes Per Allocation Unit" },
    {USTRING_CHKDSK_30,(byte *)" " },
    {USTRING_CHKDSK_32,(byte *)" Total Allocation Units On Disk" },
    {USTRING_CHKDSK_35,(byte *)" lost clusters found in " },
    {USTRING_CHKDSK_36,(byte *)" lost chains" },
    {USTRING_CHKDSK_38,(byte *)"  bad long file name chains found" },
    {USTRING_CHKDSK_39,(byte *)" and deleted" },
    {USTRING_CHKDSK_40,(byte *)" that were not deleted" },
    {USTRING_CHKDSK_41,(byte *)"      Chains Crossed at Cluster" },
    {USTRING_CHKDSK_42,(byte *)"             " },
    {USTRING_CHKDSK_43,(byte *)"       Lost Chains" },
    {USTRING_CHKDSK_44,(byte *)"       A Lost Chain" },
    {USTRING_CHKDSK_45,(byte *)"Path too deep , directory == " },
    {USTRING_CHKDSK_46,(byte *)"Failed Scanning This Directory on LFN Pass  -" },
    {USTRING_CHKDSK_47,(byte *)"Failed Scanning This Directory -" },
    {USTRING_CHKDSK_48,(byte *)"Failed Scanning This Directory -" },
    {USTRING_CHKDSK_49,(byte *)"    " },
    {USTRING_CHKDSK_50,(byte *)"Failed Scanning This File " },
    {USTRING_CHKDSK_51,(byte *)"Failed Scanning This Directory -" },
    {USTRING_CHKDSK_52,(byte *)"Failed Writing This Adusted File:    " },
    {USTRING_CHKDSK_53,(byte *)"Size Adusted, This File:    " },
    {USTRING_CHKDSK_54,(byte *)"Size Needs Adusting This File:    " },
    {USTRING_CHKDSK_55,(byte *)"Chkdsk Giving up. Too Many Lost Chains" },
    {USTRING_CHKDSK_56,(byte *)"Failed Scanning This Directory " },
    {USTRING_CHKDSK_57,(byte *)"Failed Scanning This Directory " },
    {USTRING_CHKDSK_58,(byte *)"    " },
    {USTRING_CHKDSK_59,(byte *)"Failed Scanning This File " },
    {USTRING_CHKDSK_60,(byte *)"Failed Scanning This Directory " },
    {USTRING_CHKDSK_61,(byte *)"Chkdsk gives up, too many crossed Files" },
    {USTRING_CHKDSK_62,(byte *)"Chkdsk gives up, Too many crossed chains" },
#endif
#endif /* (INCLUDE_CHKDSK_STRINGS) */
#if (INCLUDE_CRITERR_STRINGS)
#if (INCLUDE_CS_UNICODE)
    {USTRING_CRITERR_02,(byte *)L"BAD_FORMAT" },
    {USTRING_CRITERR_03,(byte *)L"CRERR_NO_CARD" },
    {USTRING_CRITERR_04,(byte *)L"CRERR_BAD_CARD" },
    {USTRING_CRITERR_05,(byte *)L"CRERR_CHANGED_CARD" },
    {USTRING_CRITERR_06,(byte *)L"CRERR_CARD_FAILURE" },
    {USTRING_CRITERR_07,(byte *)L"Media status == " },
    {USTRING_CRITERR_08,(byte *)L"Volume == " },
    {USTRING_CRITERR_09,(byte *)L"Volume is dirty" },
    {USTRING_CRITERR_10,(byte *)L"Volume is clean" },
#else
    {USTRING_CRITERR_02,(byte *)"BAD_FORMAT" },
    {USTRING_CRITERR_03,(byte *)"CRERR_NO_CARD" },
    {USTRING_CRITERR_04,(byte *)"CRERR_BAD_CARD" },
    {USTRING_CRITERR_05,(byte *)"CRERR_CHANGED_CARD" },
    {USTRING_CRITERR_06,(byte *)"CRERR_CARD_FAILURE" },
    {USTRING_CRITERR_07,(byte *)"Media status == " },
    {USTRING_CRITERR_08,(byte *)"Volume == " },
    {USTRING_CRITERR_09,(byte *)"Volume is dirty" },
    {USTRING_CRITERR_10,(byte *)"Volume is clean" },
#endif
#endif /* (INCLUDE_CRITERR_STRINGS) */
#if (INCLUDE_FLDRVER_STRINGS)
#if (INCLUDE_CS_UNICODE)
    {USTRING_FLDRVER_01,(byte *)L"Formatting " },
    {USTRING_FLDRVER_02,(byte *)L" of " },
    {USTRING_FLDRVER_03,(byte *)L" total tracks " },
    {USTRING_FLDRVER_04,(byte *)L"Format failed resid != 0" },
    {USTRING_FLDRVER_06,(byte *)L"Abnormal Termination Error FLERR_ABN_TERM" },
    {USTRING_FLDRVER_07,(byte *)L"Floppy controller not responding FLERR_CHIP_HUNG " },
    {USTRING_FLDRVER_08,(byte *)L"Dma Error FLERR_DMA " },
    {USTRING_FLDRVER_09,(byte *)L"Error during format FLERR_FORMAT " },
    {USTRING_FLDRVER_10,(byte *)L"Invalid Interleave For Media Type FLERR_INVALID_INTERLEAVE" },
    {USTRING_FLDRVER_11,(byte *)L"Sector Not Found FLERR_IO_SECTOR" },
    {USTRING_FLDRVER_12,(byte *)L"Time out FLERR_IO_TMO " },
    {USTRING_FLDRVER_13,(byte *)L"Can not determine Media FLERR_MEDIA " },
    {USTRING_FLDRVER_14,(byte *)L"Error During Recal FLERR_RECAL " },
    {USTRING_FLDRVER_15,(byte *)L"Error resetting drive FLERR_RESET " },
    {USTRING_FLDRVER_16,(byte *)L"Error during seek FLERR_SEEK " },
    {USTRING_FLDRVER_17,(byte *)L"Error during specify FLERR_SPECIFY" },
    {USTRING_FLDRVER_18,(byte *)L"Unknown Drive type FLERR_UNK_DRIVE" },
    {USTRING_FLDRVER_19,(byte *)L"Unspecified floppy error" },
#else
    {USTRING_FLDRVER_01,(byte *)"Formatting " },
    {USTRING_FLDRVER_02,(byte *)" of " },
    {USTRING_FLDRVER_03,(byte *)" total tracks " },
    {USTRING_FLDRVER_04,(byte *)"Format failed resid != 0" },
    {USTRING_FLDRVER_06,(byte *)"Abnormal Termination Error FLERR_ABN_TERM" },
    {USTRING_FLDRVER_07,(byte *)"Floppy controller not responding FLERR_CHIP_HUNG " },
    {USTRING_FLDRVER_08,(byte *)"Dma Error FLERR_DMA " },
    {USTRING_FLDRVER_09,(byte *)"Error during format FLERR_FORMAT " },
    {USTRING_FLDRVER_10,(byte *)"Invalid Interleave For Media Type FLERR_INVALID_INTERLEAVE" },
    {USTRING_FLDRVER_11,(byte *)"Sector Not Found FLERR_IO_SECTOR" },
    {USTRING_FLDRVER_12,(byte *)"Time out FLERR_IO_TMO " },
    {USTRING_FLDRVER_13,(byte *)"Can not determine Media FLERR_MEDIA " },
    {USTRING_FLDRVER_14,(byte *)"Error During Recal FLERR_RECAL " },
    {USTRING_FLDRVER_15,(byte *)"Error resetting drive FLERR_RESET " },
    {USTRING_FLDRVER_16,(byte *)"Error during seek FLERR_SEEK " },
    {USTRING_FLDRVER_17,(byte *)"Error during specify FLERR_SPECIFY" },
    {USTRING_FLDRVER_18,(byte *)"Unknown Drive type FLERR_UNK_DRIVE" },
    {USTRING_FLDRVER_19,(byte *)"Unspecified floppy error" },
#endif
#endif /* (INCLUDE_FLDRVER_STRINGS) */
#if (INCLUDE_FLASHDRV_STRINGS)
#if (INCLUDE_CS_UNICODE)
    {USTRING_FLASHDRV_01,(byte *)L"DISK FULL" },
    {USTRING_FLASHDRV_02,(byte *)L"DATA ERROR" },
    {USTRING_FLASHDRV_03,(byte *)L"DEVICE RESOURCE ERROR" },
    {USTRING_FLASHDRV_04,(byte *)L"INTERNAL ERROR" },
    {USTRING_FLASHDRV_05,(byte *)L"Flash: Exception at line " },
    {USTRING_FLASHDRV_06,(byte *)L"RTFSYSErrorExit() called at line " },
    {USTRING_FLASHDRV_07,(byte *)L"Avail count messed up" },
    {USTRING_FLASHDRV_08,(byte *)L"*** adjusting EraseCount by " },
    {USTRING_FLASHDRV_09,(byte *)L"CopyBlock from " },
    {USTRING_FLASHDRV_10,(byte *)L" To " },
    {USTRING_FLASHDRV_11,(byte *)L"Replaced " },
    {USTRING_FLASHDRV_12,(byte *)L" Copied " },
    {USTRING_FLASHDRV_13,(byte *)L"Avail " },
    {USTRING_FLASHDRV_14,(byte *)L" Recovered " },
    {USTRING_FLASHDRV_15,(byte *)L"*** Wareleveling block " },
    {USTRING_FLASHDRV_16,(byte *)L"spare block not found" },
    {USTRING_FLASHDRV_17,(byte *)L"new spare block not found" },
    {USTRING_FLASHDRV_18,(byte *)L"Writing Sector " },
    {USTRING_FLASHDRV_19,(byte *)L" count " },
    {USTRING_FLASHDRV_20,(byte *)L"flash driver: ca not find a free sector" },
    {USTRING_FLASHDRV_21,(byte *)L"flash driver: ca not find sector to write" },
    {USTRING_FLASHDRV_22,(byte *)L"flash media too large" },
    {USTRING_FLASHDRV_23,(byte *)L"flash disk OK" },
    {USTRING_FLASHDRV_24,(byte *)L"Fixing 1" },
    {USTRING_FLASHDRV_25,(byte *)L"Fixing 2" },
    {USTRING_FLASHDRV_26,(byte *)L"Fixing 3" },
    {USTRING_FLASHDRV_27,(byte *)L"Invalid sector value in flash" },
    {USTRING_FLASHDRV_28,(byte *)L"Sector found twice" },
    {USTRING_FLASHDRV_29,(byte *)L"Invalid Sector status" },
    {USTRING_FLASHDRV_30,(byte *)L"Fixing 4" },
    {USTRING_FLASHDSK_01,(byte *)L"Flash device is formatted already." },
    {USTRING_FLASHDSK_02,(byte *)L"Call again to override and format." },
#else
    {USTRING_FLASHDRV_01,(byte *)"DISK FULL" },
    {USTRING_FLASHDRV_02,(byte *)"DATA ERROR" },
    {USTRING_FLASHDRV_03,(byte *)"DEVICE RESOURCE ERROR" },
    {USTRING_FLASHDRV_04,(byte *)"INTERNAL ERROR" },
    {USTRING_FLASHDRV_05,(byte *)"Flash: Exception at line " },
    {USTRING_FLASHDRV_06,(byte *)"RTFSYSErrorExit() called at line " },
    {USTRING_FLASHDRV_07,(byte *)"Avail count messed up" },
    {USTRING_FLASHDRV_08,(byte *)"*** adjusting EraseCount by " },
    {USTRING_FLASHDRV_09,(byte *)"CopyBlock from " },
    {USTRING_FLASHDRV_10,(byte *)" To " },
    {USTRING_FLASHDRV_11,(byte *)"Replaced " },
    {USTRING_FLASHDRV_12,(byte *)" Copied " },
    {USTRING_FLASHDRV_13,(byte *)"Avail " },
    {USTRING_FLASHDRV_14,(byte *)" Recovered " },
    {USTRING_FLASHDRV_15,(byte *)"*** Wareleveling block " },
    {USTRING_FLASHDRV_16,(byte *)"spare block not found" },
    {USTRING_FLASHDRV_17,(byte *)"new spare block not found" },
    {USTRING_FLASHDRV_18,(byte *)"Writing Sector " },
    {USTRING_FLASHDRV_19,(byte *)" count " },
    {USTRING_FLASHDRV_20,(byte *)"flash driver: ca not find a free sector" },
    {USTRING_FLASHDRV_21,(byte *)"flash driver: ca not find sector to write" },
    {USTRING_FLASHDRV_22,(byte *)"flash media too large" },
    {USTRING_FLASHDRV_23,(byte *)"flash disk OK" },
    {USTRING_FLASHDRV_24,(byte *)"Fixing 1" },
    {USTRING_FLASHDRV_25,(byte *)"Fixing 2" },
    {USTRING_FLASHDRV_26,(byte *)"Fixing 3" },
    {USTRING_FLASHDRV_27,(byte *)"Invalid sector value in flash" },
    {USTRING_FLASHDRV_28,(byte *)"Sector found twice" },
    {USTRING_FLASHDRV_29,(byte *)"Invalid Sector status" },
    {USTRING_FLASHDRV_30,(byte *)"Fixing 4" },
    {USTRING_FLASHDSK_01,(byte *)"Flash device is formatted already." },
    {USTRING_FLASHDSK_02,(byte *)"Call again to override and format." },
#endif
#endif /* (INCLUDE_FLASHDRV_STRINGS) */
#if (INCLUDE_FLASHEMU_STRINGS)
#if (INCLUDE_CS_UNICODE)
    {USTRING_FLASHEMU_01,(byte *)L"Curr > Base hit" },
    {USTRING_FLASHEMU_02,(byte *)L"Flash emu hit trap" },
    {USTRING_FLASHEMU_03,(byte *)L"flash emulator: called with file not open " },
    {USTRING_FLASHEMU_04,(byte *)L"MapWindow beyond block" },
    {USTRING_FLASHEMU_05,(byte *)L"EraseBlock: block not mapped" },
    {USTRING_FLASHEMU_06,(byte *)L"ProgramData: outside Window" },
    {USTRING_FLASHEMU_07,(byte *)L"attempt to unset bits in flash!" },
#else
    {USTRING_FLASHEMU_01,(byte *)"Curr > Base hit" },
    {USTRING_FLASHEMU_02,(byte *)"Flash emu hit trap" },
    {USTRING_FLASHEMU_03,(byte *)"flash emulator: called with file not open " },
    {USTRING_FLASHEMU_04,(byte *)"MapWindow beyond block" },
    {USTRING_FLASHEMU_05,(byte *)"EraseBlock: block not mapped" },
    {USTRING_FLASHEMU_06,(byte *)"ProgramData: outside Window" },
    {USTRING_FLASHEMU_07,(byte *)"attempt to unset bits in flash!" },
#endif
#endif /* (INCLUDE_FLASHEMU_STRINGS) */
#if (INCLUDE_RTFSINIT_STRINGS)
#if (INCLUDE_CS_UNICODE)
    {USTRING_RTFSINIT_01,(byte *)L"ERTFS Device List" },
    {USTRING_RTFSINIT_02,(byte *)L"=================" },
    {USTRING_RTFSINIT_03,(byte *)L"Name Logging Disabled" },
    {USTRING_RTFSINIT_04,(byte *)L"       =         " },
    {USTRING_RTFSINIT_05,(byte *)L"Autoformatting RAM Devices" },
    {USTRING_RTFSINIT_06,(byte *)L"==========================" },
    {USTRING_RTFSINIT_07,(byte *)L"Autoformatting Drive Id - " },
    {USTRING_RTFSINIT_08,(byte *)L" as Device: " },
    {USTRING_RTFSINIT_09,(byte *)L"Failed Autoformatting Drive Id - " },
    {USTRING_RTFSINIT_10,(byte *)L"             =           " },
    {USTRING_RTFSINIT_11,(byte *)L"NDRIVES is too small to mount all devices" },
    {USTRING_RTFSINIT_12,(byte *)L"Device name : " },
    {USTRING_RTFSINIT_13,(byte *)L" Is mounted on " },
#else
    {USTRING_RTFSINIT_01,(byte *)"ERTFS Device List" },
    {USTRING_RTFSINIT_02,(byte *)"=================" },
    {USTRING_RTFSINIT_03,(byte *)"Name Logging Disabled" },
    {USTRING_RTFSINIT_04,(byte *)"       =         " },
    {USTRING_RTFSINIT_05,(byte *)"Autoformatting RAM Devices" },
    {USTRING_RTFSINIT_06,(byte *)"==========================" },
    {USTRING_RTFSINIT_07,(byte *)"Autoformatting Drive Id - " },
    {USTRING_RTFSINIT_08,(byte *)" as Device: " },
    {USTRING_RTFSINIT_09,(byte *)"Failed Autoformatting Drive Id - " },
    {USTRING_RTFSINIT_10,(byte *)"             =           " },
    {USTRING_RTFSINIT_11,(byte *)"NDRIVES is too small to mount all devices" },
    {USTRING_RTFSINIT_12,(byte *)"Device name : " },
    {USTRING_RTFSINIT_13,(byte *)" Is mounted on " },
#endif
#endif /* (INCLUDE_RTFSINIT_STRINGS) */
#if (INCLUDE_IDEDRV_STRINGS)
#if (INCLUDE_CS_UNICODE)
    {USTRING_IDEDRV_01,(byte *)L"PIO Mode set succeed" },
    {USTRING_IDEDRV_02,(byte *)L"PIO Mode set failed" },
    {USTRING_IDEDRV_03,(byte *)L"Unknown ATAPI Command Issued" },
    {USTRING_IDEDRV_04,(byte *)L"Get LBA VTOC failed" },
    {USTRING_IDEDRV_05,(byte *)L"Read Audio Failed" },
#else
    {USTRING_IDEDRV_01,(byte *)"PIO Mode set succeed" },
    {USTRING_IDEDRV_02,(byte *)"PIO Mode set failed" },
    {USTRING_IDEDRV_03,(byte *)"Unknown ATAPI Command Issued" },
    {USTRING_IDEDRV_04,(byte *)"Get LBA VTOC failed" },
    {USTRING_IDEDRV_05,(byte *)"Read Audio Failed" },
#endif
#endif /* (INCLUDE_IDEDRV_STRINGS) */
#if (INCLUDE_PORTMAIN_STRINGS)
#if (INCLUDE_CS_UNICODE)
    {USTRING_PORTMAIN_01,(byte *)L"Spawn of main task failed. change priority ?" },
    {USTRING_PORTMAIN_02,(byte *)L"Spawn of main task failed." },
#else
    {USTRING_PORTMAIN_01,(byte *)"Spawn of main task failed. change priority ?" },
    {USTRING_PORTMAIN_02,(byte *)"Spawn of main task failed." },
#endif
#endif /* (INCLUDE_PORTMAIN_STRINGS) */
#if (INCLUDE_PORTKERN_STRINGS)
#if (INCLUDE_CS_UNICODE)
    {USTRING_PORTKERN_01,(byte *)L"Spawn of timer task failed. change priority " },
    {USTRING_PORTKERN_02,(byte *)L"Spawn of timer task failed. " },
    {USTRING_PORTKERN_03,(byte *)L"pc_report_error was called with error" },
    {USTRING_PORTKERN_04,(byte *)L"Exitting and restoring interrupt vectors" },
#else
    {USTRING_PORTKERN_01,(byte *)"Spawn of timer task failed. change priority " },
    {USTRING_PORTKERN_02,(byte *)"Spawn of timer task failed. " },
    {USTRING_PORTKERN_03,(byte *)"pc_report_error was called with error" },
    {USTRING_PORTKERN_04,(byte *)"Exitting and restoring interrupt vectors" },
#endif
#endif /* (INCLUDE_PORTKERN_STRINGS) */
#if (INCLUDE_RTFSDEM_STRINGS)
#if (INCLUDE_CS_UNICODE)
    {USTRING_RTFSDEM_01,(byte *)L"pc_ertfs_init failed" },
    {USTRING_RTFSDEM_07,(byte *)L"Invalid Drive number" },
    {USTRING_RTFSDEM_08,(byte *)L"Creating Subdirectory:" },
    {USTRING_RTFSDEM_09,(byte *)L"Creating Subdirectory  " },
    {USTRING_RTFSDEM_10,(byte *)L"Creating Subdirectory   " },
    {USTRING_RTFSDEM_11,(byte *)L"Removing Directory  " },
    {USTRING_RTFSDEM_12,(byte *)L"-" },
    {USTRING_RTFSDEM_13,(byte *)L"Performing File io test" },
    {USTRING_RTFSDEM_14,(byte *)L"regress_error was called with error" },
    {USTRING_RTFSDEM_15,(byte *)L"Performing long file name test" },
    {USTRING_RTFSDEM_16,(byte *)L"Performing buffered file io test" },
    {USTRING_RTFSDEM_17,(byte *)L"Performing Large (4Gig)File io test" },
#else
    {USTRING_RTFSDEM_01,(byte *)"pc_ertfs_init failed" },
    {USTRING_RTFSDEM_07,(byte *)"Invalid Drive number" },
    {USTRING_RTFSDEM_08,(byte *)"Creating Subdirectory:" },
    {USTRING_RTFSDEM_09,(byte *)"Creating Subdirectory  " },
    {USTRING_RTFSDEM_10,(byte *)"Creating Subdirectory   " },
    {USTRING_RTFSDEM_11,(byte *)"Removing Directory  " },
    {USTRING_RTFSDEM_12,(byte *)"-" },
    {USTRING_RTFSDEM_13,(byte *)"Performing File io test" },
    {USTRING_RTFSDEM_14,(byte *)"regress_error was called with error" },
    {USTRING_RTFSDEM_15,(byte *)"Performing long file name test" },
    {USTRING_RTFSDEM_16,(byte *)"Performing buffered file io test" },
    {USTRING_RTFSDEM_17,(byte *)"Performing Large (4Gig)File io test" },
#endif
#endif /* (INCLUDE_RTFSDEM_STRINGS) */
#if (INCLUDE_TSTSH_STRINGS)
#if (INCLUDE_CS_UNICODE)
    {USTRING_TSTSH_01,(byte *)L"CD Memory init failed" },
    {USTRING_TSTSH_02,(byte *)L"Not implemented. See ide ioctl... " },
    {USTRING_TSTSH_03,(byte *)L"Set Default Drive Failed" },
    {USTRING_TSTSH_04,(byte *)L"Usage: DSKSELECT D: " },
    {USTRING_TSTSH_05,(byte *)L"No more random file slots " },
    {USTRING_TSTSH_06,(byte *)L"Cant open :" },
    {USTRING_TSTSH_07,(byte *)L"Usage: RNDOP D:PATH RECLEN" },
    {USTRING_TSTSH_08,(byte *)L"Cant find file" },
    {USTRING_TSTSH_09,(byte *)L"Close failed" },
    {USTRING_TSTSH_10,(byte *)L"Usage: CLOSE fd" },
    {USTRING_TSTSH_11,(byte *)L"Cant find file" },
    {USTRING_TSTSH_12,(byte *)L"Seek operation failed " },
    {USTRING_TSTSH_13,(byte *)L"Usage: SEEK fd recordno" },
    {USTRING_TSTSH_14,(byte *)L"Cant find file" },
    {USTRING_TSTSH_15,(byte *)L"Read operation failed " },
    {USTRING_TSTSH_16,(byte *)L"Usage: READ fd" },
    {USTRING_TSTSH_17,(byte *)L"Cant find file" },
    {USTRING_TSTSH_18,(byte *)L"Write operation failed " },
    {USTRING_TSTSH_19,(byte *)L"Usage: WRITE fd data " },
    {USTRING_TSTSH_20,(byte *)L"Usage: MKDIR D:PATH" },
    {USTRING_TSTSH_21,(byte *)L"Usage: RMDIR D:PATH" },
    {USTRING_TSTSH_22,(byte *)L"Usage: DELTREE D:PATH" },
    {USTRING_TSTSH_23,(byte *)L"deleting  --> " },
    {USTRING_TSTSH_24,(byte *)L"Can not delete: " },
    {USTRING_TSTSH_25,(byte *)L"Usage: DELETE D:PATH" },
    {USTRING_TSTSH_26,(byte *)L"Usage:  RENAME PATH NEWNAME" },
    {USTRING_TSTSH_27,(byte *)L"Set cwd failed" },
    {USTRING_TSTSH_28,(byte *)L"Get cwd failed" },
    {USTRING_TSTSH_29,(byte *)L"PWD Failed " },
    {USTRING_TSTSH_30,(byte *)L"       " },
    {USTRING_TSTSH_31,(byte *)L" File(s) " },
    {USTRING_TSTSH_32,(byte *)L" Blocks Free " },
    {USTRING_TSTSH_33,(byte *)L"Cant open " },
    {USTRING_TSTSH_34,(byte *)L"Usage: CAT PATH" },
    {USTRING_TSTSH_35,(byte *)L"Usage: CHKDSK DRIVE: WRITECHAINS" },
    {USTRING_TSTSH_36,(byte *)L"Example:CHKDSK A: 1" },
    {USTRING_TSTSH_37,(byte *)L"Runs chkdsk on A: writes lost chains" },
    {USTRING_TSTSH_38,(byte *)L"Example:CHKDSK A: 0" },
    {USTRING_TSTSH_39,(byte *)L"Runs chkdsk on A: does not write lost chains" },
    {USTRING_TSTSH_40,(byte *)L"Cant open file: " },
    {USTRING_TSTSH_41,(byte *)L"Change size function failed" },
    {USTRING_TSTSH_42,(byte *)L"Usage: CHSIZE PATH NEWSIZE" },
    {USTRING_TSTSH_43,(byte *)L"Cant open file: " },
    {USTRING_TSTSH_44,(byte *)L"Cant open file" },
    {USTRING_TSTSH_45,(byte *)L"Write failure " },
    {USTRING_TSTSH_46,(byte *)L"Usage: COPY FROMPATH TOPATH" },
    {USTRING_TSTSH_47,(byte *)L"Cant open file: " },
    {USTRING_TSTSH_48,(byte *)L"Cant open file" },
    {USTRING_TSTSH_49,(byte *)L"Files are different" },
    {USTRING_TSTSH_50,(byte *)L"File: " },
    {USTRING_TSTSH_51,(byte *)L" And File: " },
    {USTRING_TSTSH_52,(byte *)L" are the same" },
    {USTRING_TSTSH_53,(byte *)L"File: " },
    {USTRING_TSTSH_54,(byte *)L" is larger than File: " },
    {USTRING_TSTSH_55,(byte *)L"Usage: DIFF PATH PATH " },
    {USTRING_TSTSH_56,(byte *)L"Cant open file" },
    {USTRING_TSTSH_57,(byte *)L"Write failure" },
    {USTRING_TSTSH_58,(byte *)L"Usage: FILLFILE PATH PATTERN NTIMES" },
    {USTRING_TSTSH_59,(byte *)L"MODE BITS :" },
    {USTRING_TSTSH_60,(byte *)L"S_IFDIR|" },
    {USTRING_TSTSH_61,(byte *)L"S_IFREG|" },
    {USTRING_TSTSH_62,(byte *)L"S_IWRITE|" },
    {USTRING_TSTSH_63,(byte *)L"S_IREAD" },
    {USTRING_TSTSH_65,(byte *)L"FSTAT failed" },
    {USTRING_TSTSH_66,(byte *)L"Usage: FSTAT D:PATH" },
    {USTRING_TSTSH_67,(byte *)L"Calling media format" },
    {USTRING_TSTSH_68,(byte *)L"The drive is contains this many logical blocks " },
    {USTRING_TSTSH_69,(byte *)L"This many logical blocks remain" },
    {USTRING_TSTSH_70,(byte *)L"The drive contains this many cylinders" },
    {USTRING_TSTSH_71,(byte *)L"There are this many cylinders remainng" },
    {USTRING_TSTSH_72,(byte *)L"Attributes: " },
    {USTRING_TSTSH_73,(byte *)L"ARDONLY|" },
    {USTRING_TSTSH_74,(byte *)L"AHIDDEN|" },
    {USTRING_TSTSH_75,(byte *)L"ASYSTEM|" },
    {USTRING_TSTSH_76,(byte *)L"AVOLUME|" },
    {USTRING_TSTSH_77,(byte *)L"ADIRENT|" },
    {USTRING_TSTSH_78,(byte *)L"ARCHIVE|" },
    {USTRING_TSTSH_79,(byte *)L"NORMAL FILE (No bits set)" },
    {USTRING_TSTSH_81,(byte *)L"get attributes failed" },
    {USTRING_TSTSH_82,(byte *)L"Usage: GETATTR D:PATH" },
    {USTRING_TSTSH_83,(byte *)L"Can not get attributes" },
    {USTRING_TSTSH_84,(byte *)L"RDONLY" },
    {USTRING_TSTSH_85,(byte *)L"HIDDEN" },
    {USTRING_TSTSH_86,(byte *)L"SYSTEM" },
    {USTRING_TSTSH_87,(byte *)L"ARCHIVE" },
    {USTRING_TSTSH_88,(byte *)L"NORMAL" },
    {USTRING_TSTSH_89,(byte *)L"Set attributes failed" },
    {USTRING_TSTSH_90,(byte *)L"Usage: SETATTR D:PATH RDONLY|HIDDEN|SYSTEM|ARCHIVE|NORMAL" },
    {USTRING_TSTSH_91,(byte *)L"Can not open disk " },
    {USTRING_TSTSH_92,(byte *)L"Usage: DSKOPEN D:" },
    {USTRING_TSTSH_93,(byte *)L"Usage: DSKCLOSE D: " },
    {USTRING_TSTSH_94,(byte *)L"cd_set_default failed" },
    {USTRING_TSTSH_95,(byte *)L"Usage: DSKSELECT D: " },
    {USTRING_TSTSH_96,(byte *)L"path error" },
    {USTRING_TSTSH_97,(byte *)L"Cant open File" },
    {USTRING_TSTSH_98,(byte *)L"Usage: CAT PATH" },
    {USTRING_TSTSH_99,(byte *)L"Cant open :" },
    {USTRING_TSTSH_100,(byte *)L"." },
    {USTRING_TSTSH_102,(byte *)L"Usage: READ PATH" },
    {USTRING_TSTSH_103,(byte *)L"Usage: COPY CDPATH OSPATH" },
    {USTRING_TSTSH_104,(byte *)L"Cant open " },
    {USTRING_TSTSH_105,(byte *)L"Cant creat " },
    {USTRING_TSTSH_106,(byte *)L"." },
    {USTRING_TSTSH_108,(byte *)L"Write error" },
    {USTRING_TSTSH_110,(byte *)L"Usage: REGRESSTEST D:" },
#if (INCLUDE_FAILSAFE_CODE)
    {USTRING_TSTSH_111, (byte *)L"Usage: FAILSAFEINIT D:"},
    {USTRING_TSTSH_112, (byte *)L"Usage: FAILSAFECOMMIT D:"},
    {USTRING_TSTSH_113,(byte *)L"Failsafe commit failed\n"},
    {USTRING_TSTSH_114,(byte *)L"Failsafe init failed\n"},
    {USTRING_TSTSH_115,(byte *)L"Failsafe already running on a drive\n"},
    {USTRING_TSTSH_116,(byte *)L"Command shell only supports one failsafe session\n"},
    {USTRING_TSTSH_117,(byte *)L"Usage: FAILSAFERESTORE D:"},
#endif
    {USTRING_TSTSH_118,(byte *)L"Failsafe disabled"},
    {USTRING_TSTSH_119,(byte *)L"Failsafe enabled with journaling "},
    {USTRING_TSTSH_120,(byte *)L"Failsafe enabled with no journaling "},
    {USTRING_TSTSH_121,(byte *)L"Total Number of Block Buffers      "},
    {USTRING_TSTSH_122,(byte *)L"Pending writes on Block Buffers    "},
    {USTRING_TSTSH_123,(byte *)L"Block Buffers available            "},
    {USTRING_TSTSH_124,(byte *)L"Block Buffer Cache Hits            "},
    {USTRING_TSTSH_125,(byte *)L"Block Buffer Cache Misses          "},
    {USTRING_TSTSH_126,(byte *)L"Block Buffer Low Water             "},
    {USTRING_TSTSH_127,(byte *)L"Block Allocation failures          "},
    {USTRING_TSTSH_128,(byte *)L"Total Number of FAT Buffers        "},
    {USTRING_TSTSH_129,(byte *)L"FAT Buffers never used             "},
    {USTRING_TSTSH_130,(byte *)L"FAT Buffer Primary Cache Hits      "},
    {USTRING_TSTSH_131,(byte *)L"FAT Buffer Secondary Cache Hits    "},
    {USTRING_TSTSH_132,(byte *)L"FAT Buffer Secondary Cache Loads   "},
    {USTRING_TSTSH_133,(byte *)L"FAT Buffer Secondary Cache Swaps   "},
    {USTRING_TSTSH_134,(byte *)L"Pending writes on FAT Buffers      "},
    {USTRING_TSTSH_135,(byte *)L"FAT Buffers available              "},
    {USTRING_TSTSH_136,(byte *)L"pro_failsafe_status failed"},
    {USTRING_TSTSH_137,(byte *)L"USAGE: BUFFERSTAT D:"},
#if (INCLUDE_FAILSAFE_CODE)
    {USTRING_TSTSH_138,(byte *)L"FAILSAFE: Volume up to date, no restore required"},
    {USTRING_TSTSH_139,(byte *)L"FAILSAFE: no journal present"},
    {USTRING_TSTSH_140,(byte *)L"FAILSAFE: bad journal file present"},
    {USTRING_TSTSH_141,(byte *)L"FAILSAFE: journal file has checksum error"},
    {USTRING_TSTSH_142,(byte *)L"FAILSAFE: IO error during restore"},
    {USTRING_TSTSH_144,(byte *)L"FAILSAFE: Volume was restored sucessfully"},
    {USTRING_TSTSH_145,(byte *)L"FAILSAFE: Restore required"},
    {USTRING_TSTSH_146,(byte *)L"FAILSAFE: Restore unknown return code"},
#endif
    {USTRING_TSTSH_147,(byte *)L"Failsafe file blocks consumed "},
    {USTRING_TSTSH_148,(byte *)L"Failsafe file blocks still available "},

    {USTRING_TSTSHHELP_01,(byte *)L"CAT PATH" },
    {USTRING_TSTSHHELP_02,(byte *)L"CHSIZE FILENAME NEWSIZE" },
    {USTRING_TSTSHHELP_03,(byte *)L"CD PATH or CD to display PWD " },
    {USTRING_TSTSHHELP_04,(byte *)L"CDCAT PATH" },
    {USTRING_TSTSHHELP_05,(byte *)L"CDCOPY PATH PATH" },
    {USTRING_TSTSHHELP_06,(byte *)L"CDREAD PATH" },
    {USTRING_TSTSHHELP_07,(byte *)L"CDCD PATH " },
    {USTRING_TSTSHHELP_08,(byte *)L"CDDIR PATH" },
    {USTRING_TSTSHHELP_09,(byte *)L"CDDSKCLOSE: D:" },
    {USTRING_TSTSHHELP_10,(byte *)L"CDDSKOPEN: D:" },
    {USTRING_TSTSHHELP_11,(byte *)L"CDDSKSEL D:" },
    {USTRING_TSTSHHELP_12,(byte *)L"CHKDSK D: <0,1> 1 is write lost chains" },
    {USTRING_TSTSHHELP_13,(byte *)L"CLOSE FDNO" },
    {USTRING_TSTSHHELP_14,(byte *)L"COPY PATH PATH" },
    {USTRING_TSTSHHELP_15,(byte *)L"DELETE PATH" },
    {USTRING_TSTSHHELP_16,(byte *)L"DELTREE PATH" },
    {USTRING_TSTSHHELP_17,(byte *)L"DEVINFO (Display Device Information)" },
    {USTRING_TSTSHHELP_18,(byte *)L"DIFF PATH PATH" },
    {USTRING_TSTSHHELP_19,(byte *)L"DIR PATH" },
    {USTRING_TSTSHHELP_20,(byte *)L"DSKSEL D:" },
    {USTRING_TSTSHHELP_21,(byte *)L"ECHO: [args]" },
    {USTRING_TSTSHHELP_22,(byte *)L"EJECT (Trigger Remove Event)" },
    {USTRING_TSTSHHELP_23,(byte *)L"FILLFILE PATH PATTERN NTIMES" },
    {USTRING_TSTSHHELP_24,(byte *)L"FORMAT (routine will prompt for arguments)" },
    {USTRING_TSTSHHELP_25,(byte *)L"GETATTR FILE" },
    {USTRING_TSTSHHELP_26,(byte *)L"HELP:" },
    {USTRING_TSTSHHELP_27,(byte *)L"LSTOPEN (lists all open file decscriptors) " },
    {USTRING_TSTSHHELP_28,(byte *)L"MKDIR PATH" },
    {USTRING_TSTSHHELP_29,(byte *)L"PCMCIAINT (Force a PCMCIA mgmt Interrupt)" },
    {USTRING_TSTSHHELP_30,(byte *)L"QUIT" },
    {USTRING_TSTSHHELP_31,(byte *)L"READ FDNO" },
    {USTRING_TSTSHHELP_32,(byte *)L"RENAME PATH NEWNAME" },
    {USTRING_TSTSHHELP_33,(byte *)L"RMDIR PATH" },
    {USTRING_TSTSHHELP_34,(byte *)L"RNDOP PATH RECLEN" },
    {USTRING_TSTSHHELP_35,(byte *)L"SEEK FDNO RECORD" },
    {USTRING_TSTSHHELP_36,(byte *)L"SETATTR D:PATH RDONLY|HIDDEN|SYSTEM|ARCHIVE|NORMAL" },
    {USTRING_TSTSHHELP_37,(byte *)L"STAT PATH" },
    {USTRING_TSTSHHELP_38,(byte *)L"WRITE FDNO QUOTED DATA" },
    {USTRING_TSTSHHELP_39,(byte *)L"REGRESSTEST D:"},
    {USTRING_TSTSHHELP_40,(byte *)L"MKHOSTDISK win9xpath"},
    {USTRING_TSTSHHELP_41 ,(byte *)L"MKROM"},
#if (INCLUDE_FAILSAFE_CODE)
    {USTRING_TSTSHHELP_42 ,(byte *)L"FAILSAFEINIT D:"},
    {USTRING_TSTSHHELP_43 ,(byte *)L"FAILSAFECOMMIT D:"},
    {USTRING_TSTSHHELP_44 ,(byte *)L"FAILSAFERESTORE D:"},
    {USTRING_TSTSHHELP_45 ,(byte *)L"BUFFERSTAT D:"},
    {USTRING_TSTSHHELP_46 ,(byte *)L"FAILSAFETEST D: (must be hostdisk)"},
#endif /* (INCLUDE_FAILSAFE_CODE) */
    {USTRING_TSTSHCMD_01,(byte *)L"CAT" },
    {USTRING_TSTSHCMD_02,(byte *)L"CHSIZE" },
    {USTRING_TSTSHCMD_03,(byte *)L"CD" },
    {USTRING_TSTSHCMD_04,(byte *)L"CDCAT" },
    {USTRING_TSTSHCMD_05,(byte *)L"CDCOPY" },
    {USTRING_TSTSHCMD_06,(byte *)L"CDREAD" },
    {USTRING_TSTSHCMD_07,(byte *)L"CDCD" },
    {USTRING_TSTSHCMD_08,(byte *)L"CDDIR" },
    {USTRING_TSTSHCMD_09,(byte *)L"CDDSKCLOSE" },
    {USTRING_TSTSHCMD_10,(byte *)L"CDDSKOPEN" },
    {USTRING_TSTSHCMD_11,(byte *)L"CDDSKSEL" },
    {USTRING_TSTSHCMD_12,(byte *)L"CHKDSK" },
    {USTRING_TSTSHCMD_13,(byte *)L"CLOSE" },
    {USTRING_TSTSHCMD_14,(byte *)L"COPY" },
    {USTRING_TSTSHCMD_15,(byte *)L"DELETE" },
    {USTRING_TSTSHCMD_16,(byte *)L"DELTREE" },
    {USTRING_TSTSHCMD_17,(byte *)L"DEVINFO" },
    {USTRING_TSTSHCMD_18,(byte *)L"DIFF" },
    {USTRING_TSTSHCMD_19,(byte *)L"DIR" },
    {USTRING_TSTSHCMD_20,(byte *)L"DSKSEL" },
    {USTRING_TSTSHCMD_21,(byte *)L"ECHO" },
    {USTRING_TSTSHCMD_22,(byte *)L"EJECT" },
    {USTRING_TSTSHCMD_23,(byte *)L"FILLFILE" },
    {USTRING_TSTSHCMD_24,(byte *)L"FORMAT" },
    {USTRING_TSTSHCMD_25,(byte *)L"GETATTR" },
    {USTRING_TSTSHCMD_26,(byte *)L"HELP" },
    {USTRING_TSTSHCMD_27,(byte *)L"LSTOPEN" },
    {USTRING_TSTSHCMD_28,(byte *)L"MKDIR" },
    {USTRING_TSTSHCMD_29,(byte *)L"PCMCIAINT" },
    {USTRING_TSTSHCMD_30,(byte *)L"QUIT" },
    {USTRING_TSTSHCMD_31,(byte *)L"READ" },
    {USTRING_TSTSHCMD_32,(byte *)L"RENAME" },
    {USTRING_TSTSHCMD_33,(byte *)L"RMDIR" },
    {USTRING_TSTSHCMD_34,(byte *)L"RNDOP" },
    {USTRING_TSTSHCMD_35,(byte *)L"SEEK" },
    {USTRING_TSTSHCMD_36,(byte *)L"SETATTR" },
    {USTRING_TSTSHCMD_37,(byte *)L"STAT" },
    {USTRING_TSTSHCMD_38,(byte *)L"WRITE" },
    {USTRING_TSTSHCMD_39,(byte *)L"REGRESSTEST"},
    {USTRING_TSTSHCMD_40,(byte *)L"MKHOSTDISK"},
    {USTRING_TSTSHCMD_41,(byte *)L"MKROM"},
#if (INCLUDE_FAILSAFE_CODE)
    {USTRING_TSTSHCMD_42 ,(byte *)L"FAILSAFEINIT"},
    {USTRING_TSTSHCMD_43 ,(byte *)L"FAILSAFECOMMIT"},
    {USTRING_TSTSHCMD_44 ,(byte *)L"FAILSAFERESTORE"},
    {USTRING_TSTSHCMD_45 ,(byte *)L"BUFFERSTAT"},
    {USTRING_TSTSHCMD_46 ,(byte *)L"FAILSAFETEST"},
#endif /* (INCLUDE_FAILSAFE_CODE) */
#else
    {USTRING_TSTSH_01,(byte *)"CD Memory init failed" },
    {USTRING_TSTSH_02,(byte *)"Not implemented. See ide ioctl... " },
    {USTRING_TSTSH_03,(byte *)"Set Default Drive Failed" },
    {USTRING_TSTSH_04,(byte *)"Usage: DSKSELECT D: " },
    {USTRING_TSTSH_05,(byte *)"No more random file slots " },
    {USTRING_TSTSH_06,(byte *)"Cant open :" },
    {USTRING_TSTSH_07,(byte *)"Usage: RNDOP D:PATH RECLEN" },
    {USTRING_TSTSH_08,(byte *)"Cant find file" },
    {USTRING_TSTSH_09,(byte *)"Close failed" },
    {USTRING_TSTSH_10,(byte *)"Usage: CLOSE fd" },
    {USTRING_TSTSH_11,(byte *)"Cant find file" },
    {USTRING_TSTSH_12,(byte *)"Seek operation failed " },
    {USTRING_TSTSH_13,(byte *)"Usage: SEEK fd recordno" },
    {USTRING_TSTSH_14,(byte *)"Cant find file" },
    {USTRING_TSTSH_15,(byte *)"Read operation failed " },
    {USTRING_TSTSH_16,(byte *)"Usage: READ fd" },
    {USTRING_TSTSH_17,(byte *)"Cant find file" },
    {USTRING_TSTSH_18,(byte *)"Write operation failed " },
    {USTRING_TSTSH_19,(byte *)"Usage: WRITE fd data " },
    {USTRING_TSTSH_20,(byte *)"Usage: MKDIR D:PATH" },
    {USTRING_TSTSH_21,(byte *)"Usage: RMDIR D:PATH" },
    {USTRING_TSTSH_22,(byte *)"Usage: DELTREE D:PATH" },
    {USTRING_TSTSH_23,(byte *)"deleting  --> " },
    {USTRING_TSTSH_24,(byte *)"Can not delete: " },
    {USTRING_TSTSH_25,(byte *)"Usage: DELETE D:PATH" },
    {USTRING_TSTSH_26,(byte *)"Usage:  RENAME PATH NEWNAME" },
    {USTRING_TSTSH_27,(byte *)"Set cwd failed" },
    {USTRING_TSTSH_28,(byte *)"Get cwd failed" },
    {USTRING_TSTSH_29,(byte *)"PWD Failed " },
    {USTRING_TSTSH_30,(byte *)"       " },
    {USTRING_TSTSH_31,(byte *)" File(s) " },
    {USTRING_TSTSH_32,(byte *)" Blocks Free " },
    {USTRING_TSTSH_33,(byte *)"Cant open " },
    {USTRING_TSTSH_34,(byte *)"Usage: CAT PATH" },
    {USTRING_TSTSH_35,(byte *)"Usage: CHKDSK DRIVE: WRITECHAINS" },
    {USTRING_TSTSH_36,(byte *)"Example:CHKDSK A: 1" },
    {USTRING_TSTSH_37,(byte *)"Runs chkdsk on A: writes lost chains" },
    {USTRING_TSTSH_38,(byte *)"Example:CHKDSK A: 0" },
    {USTRING_TSTSH_39,(byte *)"Runs chkdsk on A: does not write lost chains" },
    {USTRING_TSTSH_40,(byte *)"Cant open file: " },
    {USTRING_TSTSH_41,(byte *)"Change size function failed" },
    {USTRING_TSTSH_42,(byte *)"Usage: CHSIZE PATH NEWSIZE" },
    {USTRING_TSTSH_43,(byte *)"Cant open file: " },
    {USTRING_TSTSH_44,(byte *)"Cant open file" },
    {USTRING_TSTSH_45,(byte *)"Write failure " },
    {USTRING_TSTSH_46,(byte *)"Usage: COPY FROMPATH TOPATH" },
    {USTRING_TSTSH_47,(byte *)"Cant open file: " },
    {USTRING_TSTSH_48,(byte *)"Cant open file" },
    {USTRING_TSTSH_49,(byte *)"Files are different" },
    {USTRING_TSTSH_50,(byte *)"File: " },
    {USTRING_TSTSH_51,(byte *)" And File: " },
    {USTRING_TSTSH_52,(byte *)" are the same" },
    {USTRING_TSTSH_53,(byte *)"File: " },
    {USTRING_TSTSH_54,(byte *)" is larger than File: " },
    {USTRING_TSTSH_55,(byte *)"Usage: DIFF PATH PATH " },
    {USTRING_TSTSH_56,(byte *)"Cant open file" },
    {USTRING_TSTSH_57,(byte *)"Write failure" },
    {USTRING_TSTSH_58,(byte *)"Usage: FILLFILE PATH PATTERN NTIMES" },
    {USTRING_TSTSH_59,(byte *)"MODE BITS :" },
    {USTRING_TSTSH_60,(byte *)"S_IFDIR|" },
    {USTRING_TSTSH_61,(byte *)"S_IFREG|" },
    {USTRING_TSTSH_62,(byte *)"S_IWRITE|" },
    {USTRING_TSTSH_63,(byte *)"S_IREAD" },
    {USTRING_TSTSH_65,(byte *)"FSTAT failed" },
    {USTRING_TSTSH_66,(byte *)"Usage: FSTAT D:PATH" },
    {USTRING_TSTSH_67,(byte *)"Calling media format" },
    {USTRING_TSTSH_68,(byte *)"The drive is contains this many logical blocks " },
    {USTRING_TSTSH_69,(byte *)"This many logical blocks remain" },
    {USTRING_TSTSH_70,(byte *)"The drive contains this many cylinders" },
    {USTRING_TSTSH_71,(byte *)"There are this many cylinders remainng" },
    {USTRING_TSTSH_72,(byte *)"Attributes: " },
    {USTRING_TSTSH_73,(byte *)"ARDONLY|" },
    {USTRING_TSTSH_74,(byte *)"AHIDDEN|" },
    {USTRING_TSTSH_75,(byte *)"ASYSTEM|" },
    {USTRING_TSTSH_76,(byte *)"AVOLUME|" },
    {USTRING_TSTSH_77,(byte *)"ADIRENT|" },
    {USTRING_TSTSH_78,(byte *)"ARCHIVE|" },
    {USTRING_TSTSH_79,(byte *)"NORMAL FILE (No bits set)" },
    {USTRING_TSTSH_81,(byte *)"get attributes failed" },
    {USTRING_TSTSH_82,(byte *)"Usage: GETATTR D:PATH" },
    {USTRING_TSTSH_83,(byte *)"Can not get attributes" },
    {USTRING_TSTSH_84,(byte *)"RDONLY" },
    {USTRING_TSTSH_85,(byte *)"HIDDEN" },
    {USTRING_TSTSH_86,(byte *)"SYSTEM" },
    {USTRING_TSTSH_87,(byte *)"ARCHIVE" },
    {USTRING_TSTSH_88,(byte *)"NORMAL" },
    {USTRING_TSTSH_89,(byte *)"Set attributes failed" },
    {USTRING_TSTSH_90,(byte *)"Usage: SETATTR D:PATH RDONLY|HIDDEN|SYSTEM|ARCHIVE|NORMAL" },
    {USTRING_TSTSH_91,(byte *)"Can not open disk " },
    {USTRING_TSTSH_92,(byte *)"Usage: DSKOPEN D:" },
    {USTRING_TSTSH_93,(byte *)"Usage: DSKCLOSE D: " },
    {USTRING_TSTSH_94,(byte *)"cd_set_default failed" },
    {USTRING_TSTSH_95,(byte *)"Usage: DSKSELECT D: " },
    {USTRING_TSTSH_96,(byte *)"path error" },
    {USTRING_TSTSH_97,(byte *)"Cant open File" },
    {USTRING_TSTSH_98,(byte *)"Usage: CAT PATH" },
    {USTRING_TSTSH_99,(byte *)"Cant open :" },
    {USTRING_TSTSH_100,(byte *)"." },
    {USTRING_TSTSH_102,(byte *)"Usage: READ PATH" },
    {USTRING_TSTSH_103,(byte *)"Usage: COPY CDPATH OSPATH" },
    {USTRING_TSTSH_104,(byte *)"Cant open " },
    {USTRING_TSTSH_105,(byte *)"Cant creat " },
    {USTRING_TSTSH_106,(byte *)"." },
    {USTRING_TSTSH_108,(byte *)"Write error" },
    {USTRING_TSTSH_110,(byte *)"Usage: REGRESSTEST D:" },
#if (INCLUDE_FAILSAFE_CODE)
    {USTRING_TSTSH_111,(byte *)"Usage: FAILSAFEINIT D:"},
    {USTRING_TSTSH_112,(byte *)"Usage: FAILSAFECOMMIT D:"},
    {USTRING_TSTSH_113,(byte *)"Failsafe commit failed\n"},
    {USTRING_TSTSH_114,(byte *)"Failsafe init failed\n"},
    {USTRING_TSTSH_115,(byte *)"Failsafe already running on a drive\n"},
    {USTRING_TSTSH_116,(byte *)"Command shell only supports one failsafe session\n"},
    {USTRING_TSTSH_117,(byte *)"Usage: FAILSAFERESTORE D:"},
#endif
    {USTRING_TSTSH_118,(byte *)"Failsafe disabled"},
    {USTRING_TSTSH_119,(byte *)"Failsafe enabled with journaling "},
    {USTRING_TSTSH_120,(byte *)"Failsafe enabled with no journaling"},
    {USTRING_TSTSH_121,(byte *)"Total Number of Block Buffers      "},
    {USTRING_TSTSH_122,(byte *)"Pending writes on Block Buffers    "},
    {USTRING_TSTSH_123,(byte *)"Block Buffers available            "},
    {USTRING_TSTSH_124,(byte *)"Block Buffer Cache Hits            "},
    {USTRING_TSTSH_125,(byte *)"Block Buffer Cache Misses          "},
    {USTRING_TSTSH_126,(byte *)"Block Buffer Low Water             "},
    {USTRING_TSTSH_127,(byte *)"Block Allocation failures          "},
    {USTRING_TSTSH_128,(byte *)"Total Number of FAT Buffers        "},
    {USTRING_TSTSH_129,(byte *)"FAT Buffers never used             "},
    {USTRING_TSTSH_130,(byte *)"FAT Buffer Primary Cache Hits      "},
    {USTRING_TSTSH_131,(byte *)"FAT Buffer Secondary Cache Hits    "},
    {USTRING_TSTSH_132,(byte *)"FAT Buffer Secondary Cache Loads   "},
    {USTRING_TSTSH_133,(byte *)"FAT Buffer Secondary Cache Swaps   "},
    {USTRING_TSTSH_134,(byte *)"Pending writes on FAT Buffers      "},
    {USTRING_TSTSH_135,(byte *)"FAT Buffers available              "},
    {USTRING_TSTSH_136,(byte *)"pro_failsafe_status failed"},
    {USTRING_TSTSH_137,(byte *)"USAGE: BUFFERSTAT D:"},
#if (INCLUDE_FAILSAFE_CODE)
    {USTRING_TSTSH_138,(byte *)"FAILSAFE: Volume up to date, no restore required"},
    {USTRING_TSTSH_139,(byte *)"FAILSAFE: no journal present"},
    {USTRING_TSTSH_140,(byte *)"FAILSAFE: bad journal file present"},
    {USTRING_TSTSH_141,(byte *)"FAILSAFE: journal file has checksum error"},
    {USTRING_TSTSH_142,(byte *)"FAILSAFE: IO error during restore"},
    {USTRING_TSTSH_144,(byte *)"FAILSAFE: Volume was restored sucessfully"},
    {USTRING_TSTSH_145,(byte *)"FAILSAFE: Restore required"},
    {USTRING_TSTSH_146,(byte *)"FAILSAFE: Restore unknown return code"},
#endif
    {USTRING_TSTSH_147,(byte *)"Failsafe file blocks consumed "},
    {USTRING_TSTSH_148,(byte *)"Failsafe file blocks still available "},

    {USTRING_TSTSHHELP_01,(byte *)"CAT PATH" },
    {USTRING_TSTSHHELP_02,(byte *)"CHSIZE FILENAME NEWSIZE" },
    {USTRING_TSTSHHELP_03,(byte *)"CD PATH or CD to display PWD " },
    {USTRING_TSTSHHELP_04,(byte *)"CDCAT PATH" },
    {USTRING_TSTSHHELP_05,(byte *)"CDCOPY PATH PATH" },
    {USTRING_TSTSHHELP_06,(byte *)"CDREAD PATH" },
    {USTRING_TSTSHHELP_07,(byte *)"CDCD PATH " },
    {USTRING_TSTSHHELP_08,(byte *)"CDDIR PATH" },
    {USTRING_TSTSHHELP_09,(byte *)"CDDSKCLOSE: D:" },
    {USTRING_TSTSHHELP_10,(byte *)"CDDSKOPEN: D:" },
    {USTRING_TSTSHHELP_11,(byte *)"CDDSKSEL D:" },
    {USTRING_TSTSHHELP_12,(byte *)"CHKDSK D: <0,1> 1 is write lost chains" },
    {USTRING_TSTSHHELP_13,(byte *)"CLOSE FDNO" },
    {USTRING_TSTSHHELP_14,(byte *)"COPY PATH PATH" },
    {USTRING_TSTSHHELP_15,(byte *)"DELETE PATH" },
    {USTRING_TSTSHHELP_16,(byte *)"DELTREE PATH" },
    {USTRING_TSTSHHELP_17,(byte *)"DEVINFO (Display Device Information)" },
    {USTRING_TSTSHHELP_18,(byte *)"DIFF PATH PATH" },
    {USTRING_TSTSHHELP_19,(byte *)"DIR PATH" },
    {USTRING_TSTSHHELP_20,(byte *)"DSKSEL D:" },
    {USTRING_TSTSHHELP_21,(byte *)"ECHO: [args]" },
    {USTRING_TSTSHHELP_22,(byte *)"EJECT (Trigger Remove Event)" },
    {USTRING_TSTSHHELP_23,(byte *)"FILLFILE PATH PATTERN NTIMES" },
    {USTRING_TSTSHHELP_24,(byte *)"FORMAT (routine will prompt for arguments)" },
    {USTRING_TSTSHHELP_25,(byte *)"GETATTR FILE" },
    {USTRING_TSTSHHELP_26,(byte *)"HELP:" },
    {USTRING_TSTSHHELP_27,(byte *)"LSTOPEN (lists all open file decscriptors) " },
    {USTRING_TSTSHHELP_28,(byte *)"MKDIR PATH" },
    {USTRING_TSTSHHELP_29,(byte *)"PCMCIAINT (Force a PCMCIA mgmt Interrupt)" },
    {USTRING_TSTSHHELP_30,(byte *)"QUIT" },
    {USTRING_TSTSHHELP_31,(byte *)"READ FDNO" },
    {USTRING_TSTSHHELP_32,(byte *)"RENAME PATH NEWNAME" },
    {USTRING_TSTSHHELP_33,(byte *)"RMDIR PATH" },
    {USTRING_TSTSHHELP_34,(byte *)"RNDOP PATH RECLEN" },
    {USTRING_TSTSHHELP_35,(byte *)"SEEK FDNO RECORD" },
    {USTRING_TSTSHHELP_36,(byte *)"SETATTR D:PATH RDONLY|HIDDEN|SYSTEM|ARCHIVE|NORMAL" },
    {USTRING_TSTSHHELP_37,(byte *)"STAT PATH" },
    {USTRING_TSTSHHELP_38,(byte *)"WRITE FDNO QUOTED DATA" },
    {USTRING_TSTSHHELP_39,(byte *)"REGRESSTEST D:"},
    {USTRING_TSTSHHELP_40,(byte *)"MKHOSTDISK win9xpath"},
    {USTRING_TSTSHHELP_41 ,(byte *)"MKROM"},
#if (INCLUDE_FAILSAFE_CODE)
    {USTRING_TSTSHHELP_42 ,(byte *)"FAILSAFEINIT D:"},
    {USTRING_TSTSHHELP_43 ,(byte *)"FAILSAFECOMMIT D:"},
    {USTRING_TSTSHHELP_44 ,(byte *)"FAILSAFERESTORE D:"},
    {USTRING_TSTSHHELP_45 ,(byte *)"BUFFERSTAT D:"},
    {USTRING_TSTSHHELP_46 ,(byte *)"FAILSAFETEST D: (must be hostdisk)"},
#endif /* (INCLUDE_FAILSAFE_CODE) */
    {USTRING_TSTSHCMD_01,(byte *)"CAT" },
    {USTRING_TSTSHCMD_02,(byte *)"CHSIZE" },
    {USTRING_TSTSHCMD_03,(byte *)"CD" },
    {USTRING_TSTSHCMD_04,(byte *)"CDCAT" },
    {USTRING_TSTSHCMD_05,(byte *)"CDCOPY" },
    {USTRING_TSTSHCMD_06,(byte *)"CDREAD" },
    {USTRING_TSTSHCMD_07,(byte *)"CDCD" },
    {USTRING_TSTSHCMD_08,(byte *)"CDDIR" },
    {USTRING_TSTSHCMD_09,(byte *)"CDDSKCLOSE" },
    {USTRING_TSTSHCMD_10,(byte *)"CDDSKOPEN" },
    {USTRING_TSTSHCMD_11,(byte *)"CDDSKSEL" },
    {USTRING_TSTSHCMD_12,(byte *)"CHKDSK" },
    {USTRING_TSTSHCMD_13,(byte *)"CLOSE" },
    {USTRING_TSTSHCMD_14,(byte *)"COPY" },
    {USTRING_TSTSHCMD_15,(byte *)"DELETE" },
    {USTRING_TSTSHCMD_16,(byte *)"DELTREE" },
    {USTRING_TSTSHCMD_17,(byte *)"DEVINFO" },
    {USTRING_TSTSHCMD_18,(byte *)"DIFF" },
    {USTRING_TSTSHCMD_19,(byte *)"DIR" },
    {USTRING_TSTSHCMD_20,(byte *)"DSKSEL" },
    {USTRING_TSTSHCMD_21,(byte *)"ECHO" },
    {USTRING_TSTSHCMD_22,(byte *)"EJECT" },
    {USTRING_TSTSHCMD_23,(byte *)"FILLFILE" },
    {USTRING_TSTSHCMD_24,(byte *)"FORMAT" },
    {USTRING_TSTSHCMD_25,(byte *)"GETATTR" },
    {USTRING_TSTSHCMD_26,(byte *)"HELP" },
    {USTRING_TSTSHCMD_27,(byte *)"LSTOPEN" },
    {USTRING_TSTSHCMD_28,(byte *)"MKDIR" },
    {USTRING_TSTSHCMD_29,(byte *)"PCMCIAINT" },
    {USTRING_TSTSHCMD_30,(byte *)"QUIT" },
    {USTRING_TSTSHCMD_31,(byte *)"READ" },
    {USTRING_TSTSHCMD_32,(byte *)"RENAME" },
    {USTRING_TSTSHCMD_33,(byte *)"RMDIR" },
    {USTRING_TSTSHCMD_34,(byte *)"RNDOP" },
    {USTRING_TSTSHCMD_35,(byte *)"SEEK" },
    {USTRING_TSTSHCMD_36,(byte *)"SETATTR" },
    {USTRING_TSTSHCMD_37,(byte *)"STAT" },
    {USTRING_TSTSHCMD_38,(byte *)"WRITE" },
    {USTRING_TSTSHCMD_39,(byte *)"REGRESSTEST"},
    {USTRING_TSTSHCMD_40,(byte *)"MKHOSTDISK"},
    {USTRING_TSTSHCMD_41,(byte *)"MKROM"},
#if (INCLUDE_FAILSAFE_CODE)
    {USTRING_TSTSHCMD_42 ,(byte *)"FAILSAFEINIT"},
    {USTRING_TSTSHCMD_43 ,(byte *)"FAILSAFECOMMIT"},
    {USTRING_TSTSHCMD_44 ,(byte *)"FAILSAFERESTORE"},
    {USTRING_TSTSHCMD_45 ,(byte *)"BUFFERSTAT"},
    {USTRING_TSTSHCMD_46 ,(byte *)"FAILSAFETEST"},
#endif /* (INCLUDE_FAILSAFE_CODE) */

#endif
#endif /* (INCLUDE_TSTSH_STRINGS) */
#if (INCLUDE_CS_UNICODE)
    {0,(byte *)L"Unkown User String" }
#else
    {0,(byte *)"Unkown User String" }
#endif
    };



static byte *rtfs_strtab_string(KS_CONSTANT RTFS_STRING_TABLE *ptable, int string_id)
{
    while (ptable->string_id != 0)
    {
        if (ptable->string_id == string_id)
            break;
        ptable++;
    }
    /* Return prompt. If lookup failed return Unkown User Prompt */
    return((byte *)ptable->string_value);
}

byte *rtfs_strtab_user_prompt(int prompt_id)
{
    return(rtfs_strtab_string(prompt_table, prompt_id));
}

byte *rtfs_strtab_user_string(int string_id)
{
    return(rtfs_strtab_string(string_table, string_id));
}
