/*---------------------------------------------------------------------------*
  Project:  wfs
  File:     wfs_Client.h - Internal definitions for the PPC side of the WFS API


  Copyright 2007 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: wfs_Client.h,v $
  Revision 1.4  2007/11/02 00:20:34  paul
  started logging changes in the file

 *---------------------------------------------------------------------------*/

// File created 2007.08.29

#ifndef wfs_Client_h
#define wfs_Client_h

#ifdef _DEBUG
    #define _DEBUG_WFS_CLIENT 1
#else
    #define _DEBUG_WFS_CLIENT 0
#endif

#include "wfs_Heap.h"
#include "wfs_AsyncUtils.h"
#include "wfscli_Handles.h"
#include "wfssrv_Defs.h"

typedef struct {
    bool               bMutexInitialized;
    WFSMutex           mxAccessDeviceCallbackGlobals;
    utf8              *pAttachDeviceNameBuffer;
    WFSDeviceCallback  cbAttachDevice;
    void              *pAttachDeviceUserData;

    utf8              *pDetachDeviceNameBuffer;
    WFSDeviceCallback  cbDetachDevice;
    void              *pDetachDeviceUserData;
} WFSDeviceCallbackGlobals;

typedef struct {
    bool                     bLibInitialized;
    void                    *pWorkSpaceBuffer;
    WFSHeap                  heap;
    WFSCliHandles            hnd;
    WFSAsyncGlobals          ag;
    WFSPathGlobals           pg;
    WFSDeviceCallbackGlobals dcg;
} WFSClientGlobals;

typedef struct {
    WFSSrvFunc nFunction;
    WFSPath    pathAbs;
} WFSFuncParams_OnePathName;

extern WFSClientGlobals wcg;

#endif //wfs_Client_h
