/*---------------------------------------------------------------------------*
  Project:  wfs
  File:     wfs_Defs.h

  Copyright 2007 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: wfs_Defs.h,v $
  Revision 1.14  2008/11/05 15:11:45  ueno
  Fixed WFS_ROUND_DOWN().

  Revision 1.13  2008/07/11 05:27:22  kondo_masahiro
  Fixed WFS_ROUND_UP / DOWN

  Revision 1.11  2008/04/19 05:52:44  kondo_masahiro
  Fixed code to accept RM compiler

  Revision 1.10  2007/12/28 07:33:23  nakanose_jin
  fix bug

  Revision 1.9  2007/12/26 10:17:44  paul
  WFS_RANGE_CHK, WFS_INDEX_COUNT ǉ

  Revision 1.8  2007/11/06 22:44:18  paul
  added wfs_Errors.h to list of included headers

  Revision 1.7  2007/11/05 18:39:16  paul
  removed unused macro

  Revision 1.6  2007/11/02 00:24:51  paul
  started logging changes in the file

*---------------------------------------------------------------------------*/

#ifndef wfs_Defs_h
#define wfs_Defs_h


#define _WIN32_WINNT 0x500

#include "revolution/wfs.h"
#include "wfs_Platform.h"
#include "wfs_Config.h"
#include "wfs_Errors.h"
#include "wfs_Types.h"

#if !_IOP
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#endif

#define WFS_ROUND_UP(v,x)   (((v)+(x)-1)&-((signed)x))
#define WFS_ROUND_DOWN(v,x) ((v)&-((signed)x))

#define WFS_RANGE_CHK(val,min,max) (((val)>=(min))&&((val)<(max)))
#define WFS_INDEX_COUNT(array) (size_t)(sizeof(array)/sizeof(array[0]))

#define BYTES2BITS(b)        ((b)<<3)

#ifndef swap_typ
    #define swap_typ(Typ,a,b) { Typ t=a; a=b; b=t; }
#endif

#ifdef _DEBUG
    #ifndef _ASSERT
        #define _ASSERT(x) ASSERT(x)
    #endif
#else
    #ifndef _ASSERT
        #define _ASSERT(x)
    #endif
#endif


#endif // wfs_defs_h
