/*---------------------------------------------------------------------------*
  Project:  wfs
  File:     wfskrn_DirFind.h - Find functions for the Directory Module

  Copyright 2007-2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: wfskrn_DirFind.h,v $
  Revision 1.3  2008/05/16 18:54:09  paul
  Added DirFindNext()

  Revision 1.2  2008/05/10 04:00:48  kondo_masahiro
  Merged and fixed code to accept RM compiler

  Revision 1.1  2008/04/24 23:21:18  kondo_masahiro
  Initial check-in

  Revision 1.1  2008/04/23 00:34:38  paul
  Split off from wfskrn_Dir.cpp


*---------------------------------------------------------------------------*/

#ifndef wfskrn_DirFind_h
#define wfskrn_DirFind_h

#define DIR_FIND_MODE_NORMAL              0
#define DIR_FIND_MODE_PREFIX_SEARCH       1
#define DIR_FIND_MODE_NODE_SEARCH         2

WFSKrnResult DirFind(WFSFileName *pName, DirItr *pDi, u32 nMaxBlkDepth, u32 nMode);
WFSKrnResult DirFindNext(WFSFileName *pName, DirItr *pDi);

#endif //define wfskrn_DirFind_h
