/*---------------------------------------------------------------------------*
  Project:  wfs
  File:     wfskrn_Heap.h - memory allocation functions

  Copyright 2007 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: wfskrn_Heap.h,v $
  Revision 1.1  2008/04/22 04:39:08  kondo_masahiro
  Fixed code to transfer the wfskrn project to RM_SDK tree

  Revision 1.1  2007/12/27 11:35:11  paul
  similar to wfs_Heap, but will eventually support IOP

 *---------------------------------------------------------------------------*/

#ifndef wfskrn_Heap_h
#define wfskrn_Heap_h


#include "wfskrn_Defs.h"

#ifdef _DEBUG
    #define _DEBUG_WFSKRN_ALLOC 0  // change to 1 if debug info required
#else
    #define _DEBUG_WFSKRN_ALLOC 0
#endif

#if _WIN32

typedef HANDLE WFSKrnHeap;

//-- twl modified
#elif _TWL

typedef OSHeapHandle WFSKrnHeap;

//-- twl modified

#elif _RVL

#include <revolution/mem.h>
#define WFS_HEAP_DEFAULT_ALIGNMENT 32

typedef struct {
    MEMAllocator  allocator;
    MEMHeapHandle handle;
} WFSKrnHeap;

#elif _IOP

#define WFSKrnHeap IOSHeapId

#endif

void WFSKrnCreateHeap(WFSKrnHeap *pHeap, void *pBase, size_t nSize);
void *WFSKrnHeapAlloc(WFSKrnHeap *pHeap, size_t nSize);
void WFSKrnHeapFree(WFSKrnHeap *pHeap, void *pAddr);
void WFSKrnHeapDestroy(WFSKrnHeap *pHeap);

#endif //define wfskrn_Heap_h
