/*---------------------------------------------------------------------------*
  Project:  wfs
  File:     wfs_Permission.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: wfskrn_Permission.h,v $
  Revision 1.5  2008/12/18 10:28:33  ooizumi
  Fixed macro.

  Revision 1.4  2008/12/04 00:49:49  ooizumi
  Removed old codes.
  Fixed.

  Revision 1.3  2008/07/31 23:59:09  ooizumi
  Fixed permission of special directories..

  Revision 1.2  2008/07/30 06:04:34  ooizumi
  Added definitions for permission.

  Revision 1.1  2008/04/22 04:39:08  kondo_masahiro
  Fixed code to transfer the wfskrn project to RM_SDK tree

  Revision 1.6  2008/02/28 04:36:47  ueno
  Cleanup.

  Revision 1.5  2008/02/27 10:05:26  ueno
  Revised to use WFSAreaHdr{} to specifiy WFS area.

  Revision 1.4  2008/02/27 04:33:36  ueno
  Added root ID and alias permission flags.

  Revision 1.3  2008/02/26 14:12:06  ueno
  Added WFSAccessListAddEntry() and WFSAccessListRemoveEntry() to edit accesslist.

  Revision 1.2  2008/02/25 09:44:08  ueno
  Added support for accesslist cache.

  Revision 1.1  2008/02/22 05:15:55  ueno
  Initial Check-in.


*---------------------------------------------------------------------------*/
#ifndef __WFS_PERMISSION_H__
#define __WFS_PERMISSION_H__

#ifdef _DEBUG

#ifdef WIN32
#define WFSKRN_PERM_ASSERT(x)    assert(x)
//#define WFSKRN_PERM_REPORT  printf
#define WFSKRN_PERM_REPORT
#else  // Win32
#define WFSKRN_PERM_ASSERT(x)    SDK_ASSERT(x)
//#define WFSKRN_PERM_REPORT(...)  printf(__VA_ARGS__)
#define WFSKRN_PERM_REPORT       osTPrintf
#endif // WIN32

#else // _DEBUG

#define WFSKRN_PERM_ASSERT(x)   SDK_ASSERT(x)
#define WFSKRN_PERM_REPORT(...) osTPrintf(__VA_ARGS__)
//#define WFSKRN_PERM_ASSERT(x)
//#define WFSKRN_PERM_REPORT(...)

#endif // _DEBUG

WFSKrnResult WFSKrnGetInheritedPermissionForUserDi(PathCacheItr* pPci, u32* pFlags, WFSTitleId titleId);
WFSKrnResult WFSKrnGetInheritedPermissionForUserPci(PathCacheItr* pPci, u32* pFlags, WFSTitleId titleId);
WFSKrnResult WFSKrnGetParentInheritedPermissionForUserPci(PathCacheItr* pPci, u32* pFlags, WFSTitleId titleId);
WFSKrnResult WFSKrnSetInheritedPermissionForUser(PathCacheItr* pPci, u32 nFlags, u32 nMask, WFSTitleId entryCreatorId, WFSTitleId titleId);

#endif // __WFS_PERMISSION_H__
