/*---------------------------------------------------------------------------*
  Project:  TWL - rtfs interface for SD Memory Card
  File:     drnand.h

  Copyright 2006-2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
  
  $Date:: #$
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/

#include <brom.h>
#include <brom/nand/nand.h>
#include <sdmc.h>
#include <drnand.h>

#define PRINTDEBUG( ...) ((void)0)
/*
#if (SD_DEBUG_PRINT_ON == 1)
    #define PRINTDEBUG    osTPrintf
#else
    #define PRINTDEBUG( ...) ((void)0)
#endif
*/

/*---------------------------------------------------------------------------*
  萔
 *---------------------------------------------------------------------------*/
#define NUM_SD_PAGES
#define SD_PAGE_SIZE


/*---------------------------------------------------------------------------*
  externϐ
 *---------------------------------------------------------------------------*/
/*SDJ[h̃XybN\*/
SdmcSpec    sdmc_current_spec;


/*---------------------------------------------------------------------------*
  extern֐
 *---------------------------------------------------------------------------*/
extern void nandReset( void);
void i_nandCalcSize( void); //TODO:sdmc_current_spec\̂ɓ邱
BOOL nandCrashBootSectors( u32* buf);


/*---------------------------------------------------------------------------*
  staticϐ
 *---------------------------------------------------------------------------*/
static FATSpec NandFatSpec[4]; //FATp[^(p[eBV0`3)
static int     nand_calculated_fat_params = 0;


/*---------------------------------------------------------------------------*
  static֐
 *---------------------------------------------------------------------------*/
BOOL nandFillPartition( int partition_no, u32* buf, u32 blocks);
void i_nandCalcSize( void);


#if 1    //AvP[VŃp[eBV\߂Ƃ

u32 NAND_FAT_PARTITION_COUNT;
u32 NAND_RAW_SECTORS;
u32 NAND_FAT0_SECTORS = 0;
u32 NAND_FAT1_SECTORS;
u32 NAND_FAT2_SECTORS;
u32 NAND_FAT3_SECTORS;

void nandSetFormatRequest( u16 partition_num, u32* partition_sectors);
void nandSetFormatRequest( u16 partition_num, u32* partition_sectors)
{
    NAND_RAW_SECTORS  = partition_sectors[0];
    NAND_FAT0_SECTORS = partition_sectors[1] + NAND_RAW_SECTORS;
    NAND_FAT1_SECTORS = partition_sectors[2];
    NAND_FAT2_SECTORS = partition_sectors[3];
    NAND_FAT3_SECTORS = partition_sectors[4];
    NAND_FAT_PARTITION_COUNT = partition_num;
}

#else    //p[eBV\ߑłƂ
/* RAW:1MB, FAT0:206MB, FAT1:32.75MB */
#define NAND_FAT_PARTITION_COUNT (3)
#define NAND_RAW_SECTORS     (( 1*1024*1024)/512);
#define NAND_FAT0_SECTORS    (((206*1024*1024)/512) + NAND_RAW_SECTORS); //vZRAW܂߂Ă
#define NAND_FAT1_SECTORS    ((33536*1024)/512);
#define NAND_FAT2_SECTORS    (( 1*1024*1024)/512);
#define NAND_FAT3_SECTORS    (0);

#endif


/*---------------------------------------------------------------------------*
  Name:         nandNfsIo

  Description:  ʑw̃ZN^[h^Cgv󂯂

  Arguments:    driveno : hCuԍ
                block : JnubNԍ
                buffer : 
                count : ubN
                reading : [hvTRUE

  Returns:      TRUE/FALSE
 *---------------------------------------------------------------------------*/
BOOL nandNfsIo( int driveno, u32 block, void* buffer, u16 count, BOOL reading)
{
    if( reading) {
        PRINTDEBUG( "DEVCTL_IO_READ ... block:%x, count:%x -> buf:%x\n", block, count, buffer);
        nandReadSector( buffer, block, count);
    }else{
        PRINTDEBUG( "DEVCTL_IO_WRITE ... block:%x, count:%x <- buf:%x\n", block, count, buffer);
        nandWriteSector( buffer, block, count);
    }

    return TRUE;
}

/*---------------------------------------------------------------------------*
  Name:         nandNfsCtrl

  Description:  ʑw̃Rg[v󂯂

  Arguments:    driveno : hCuԍ
                opcode : v̎
                pargs : 

  Returns:
  Memo :        DRIVE_FLAGS_REMOVABLȄꍇAhCoIO֐ĂԑO
                CTRL֐DEVCTL_CHECK_STATUSĂ΂B
                DEVTEST_CHANGEDDEVTEST_NOCHANGEmFRTFS̓ZN^0
                ǂ݂ɍsAFATp[^擾ŖړĨZN^ǂ݂ɍsB
                CTRL֐̑OɂDEVCTL_CHECK_STATUSĂ΂Ȃ̂ŁADEVCTL_
                GET_GEOMETRYł͎Oōđ}`FbNKvB
 *---------------------------------------------------------------------------*/
int nandNfsCtrl( int driveno, int opcode, void* pargs)
{
    switch( opcode) {
      case NFS_DEVCTL_GET_GEOMETRY:    //format܂partirionƂRTFSgp[^
        i_nandCalcSize();
        *(u32*)pargs = sdmc_current_spec.memory_capacity; 
        return( 0);
        
      case NFS_DEVCTL_FORMAT:
        PRINTDEBUG( "DEVCTL_FORMAT\n");
        return( 0);

      case NFS_DEVCTL_REPORT_REMOVE:        //ꂽƂ
        PRINTDEBUG( "DEVCTL_REPORT_REMOVE\n");
        return( 0);
        
      case NFS_DEVCTL_CHECKSTATUS:    //REMOVABLȄꍇAR/WOɌĂ΂
        PRINTDEBUG( "DEVCTL_CHECKSTATUS\n");
            return(DEVTEST_NOCHANGE);
//        }
        
      case NFS_DEVCTL_WARMSTART:    //attacĥƂĂ΂Ȃ
        PRINTDEBUG( "DEVCTL_WARMSTART\n");
        /*-- NAND̂ݏ --*/
//        nandReset();
        /*--------------------*/
        return( 0);
        
      case NFS_DEVCTL_POWER_RESTORE:
        PRINTDEBUG( "DEVCTL_POWER_RESTORE\n");
        break;
        
      case NFS_DEVCTL_POWER_LOSS:
        PRINTDEBUG( "DEVCTL_POWER_LOSS\n");
        break;
        
      default:
        PRINTDEBUG( "DEVCTL_unknown\n");
        break;
    }
    return( 0);
}

/*---------------------------------------------------------------------------*
  Name:         i_nandCalcSize

  Description:

  Arguments:

  Returns:      None
 *---------------------------------------------------------------------------*/
void i_nandCalcSize( void)
{
    sdmc_current_spec.csd_ver2_flag = 0;
    sdmc_current_spec.protected_capacity = (20*256); //20Blocks
    sdmc_current_spec.card_capacity      = NAND_GUARANTEED_SECTORS;
    sdmc_current_spec.memory_capacity    = sdmc_current_spec.card_capacity -
                                           sdmc_current_spec.protected_capacity;
}


//#endif /*(INCLUDE_SD)*/
