/*---------------------------------------------------------------------------*
  Project:  CtrBrom - HW - include
  File:     mmap_axi_wram.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::           $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef FIRM_HW_ARM11_AXI_WRAM_H_
#define FIRM_HW_ARM11_AXI_WRAM_H_

#include <ctr/hw/arm11/mmap_axi_wram.h>

#ifdef __cplusplus
extern "C" {
#endif

// for OS

//------------------------------------- HW_FIRM_STACK
#define HW_FIRM_STACK                   (HW_FIRM_STACK_END - HW_FIRM_STACK_SIZE)
#define HW_FIRM_STACK_END               HW_FIRM_MMU_TBL
#define HW_FIRM_STACK_SIZE              0x4000  // 16KB

#define HW_FIRM_SVC_STACK               (HW_FIRM_SVC_STACK_END - HW_FIRM_SVC_STACK_SIZE)
#define HW_FIRM_SVC_STACK_END           HW_FIRM_STACK_END
#define HW_FIRM_SVC_STACK_SIZE          0x100  // 256B

#define HW_FIRM_IRQ_STACK               (HW_FIRM_IRQ_STACK_END - HW_FIRM_IRQ_STACK_SIZE)
#define HW_FIRM_IRQ_STACK_END           HW_FIRM_SVC_STACK
#define HW_FIRM_IRQ_STACK_SIZE          (0x1000 - HW_FIRM_SVC_STACK_SIZE)  // 4KB - 256B

#define HW_FIRM_SYS_STACK               (HW_FIRM_SYS_STACK_END - HW_FIRM_SYS_STACK_SIZE)
#define HW_FIRM_SYS_STACK_END           HW_FIRM_IRQ_STACK
#define HW_FIRM_SYS_STACK_SIZE          (HW_FIRM_STACK_SIZE - HW_FIRM_IRQ_STACK_SIZE - HW_FIRM_SVC_STACK_SIZE)  // 12KB

//------------------------------------- HW_FIRM_MMU_TBL
#define HW_FIRM_MMU_TBL                 (HW_FIRM_MMU_TBL_END - HW_FIRM_MMU_TBL_SIZE)
#define HW_FIRM_MMU_TBL_END             HW_FIRM_FROM_BROM_BUF // (16+8)KB
#define HW_FIRM_MMU_TBL_SIZE            (HW_FIRM_MMU_T1_SIZE + HW_FIRM_MMU_T2_SIZE)  // 24KB

#define HW_FIRM_MMU_T1                  HW_FIRM_MMU_TBL
#define HW_FIRM_MMU_T2                  HW_FIRM_MMU_T1_END
#define HW_FIRM_MMU_T1_END              (HW_FIRM_MMU_T1 + HW_FIRM_MMU_T1_SIZE)
#define HW_FIRM_MMU_T2_END              (HW_FIRM_MMU_T2 + HW_FIRM_MMU_T2_SIZE)
#define HW_FIRM_MMU_T1_SIZE             0x4000  // 16KB
#define HW_FIRM_MMU_T2_SIZE             0x2000  // 8KB

// for FIRM

//------------------------------------- HW_FIRM_FROM_BROM_BUF
#define HW_FIRM_FROM_BROM_BUF           (HW_FIRM_FROM_BROM_BUF_END - HW_FIRM_FROM_BROM_BUF_SIZE) // 24KB
#define HW_FIRM_FROM_BROM_BUF_END       HW_AXI_WRAM_SHARED // 8KB
#define HW_FIRM_FROM_BROM_BUF_SIZE      0x4000  // 16KB


#ifdef __cplusplus
} /* extern "C" */
#endif
/* FIRM_HW_ARM11_AXI_WRAM_H_ */
#endif
