/*---------------------------------------------------------------------------*
  Project:  ctr_firmware - format
  File:     firm.h

  Copyright 2009 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef FORMAT_FIRM_H_
#define FORMAT_FIRM_H_

#ifdef __cplusplus
extern "C" {
#endif


/*===========================================================================*
 *  FIRM FORMAT
 *===========================================================================*/

/*---------------------------------------------------------------------------*
 *  {p[^
 *---------------------------------------------------------------------------*/

#define FIRM_FORMAT_HASH_LENGTH     32  // SHA-256 or HMAC-SHA-256
#define FIRM_FORMAT_SIGN_LENGTH     256 // RSA-2048 with PKCS#1 v1.5
#define FIRM_FORMAT_MAX_MODULES     4

#define FIRM_FORMAT_MAGIC_NUMBER    ( 'F'<<0 | 'I'<<8 | 'R'<<16 | 'M'<<24 )
#define FIRM_FORMAT_FIRST_VIRSION   0

/*
   CTRt@[͓̃p[eBV11܂߂邱Ƃł
   ǂ̃p[eBVA邩ɂĂ͕ʓrfBAwb_Œ`
   (ftHg: 0x1000ȍ~1)
*/

typedef struct FirmHash
{
    u8 raw[FIRM_FORMAT_HASH_LENGTH];
}
FirmHash;

typedef struct FirmSign
{
    u8 raw[FIRM_FORMAT_SIGN_LENGTH];
}
FirmSign;

typedef struct FirmModule
{
    u32         sourceOffset;       // FirmHeader̐擪̃ItZbg (512BEɐ)
    void*       destinationAddress; // ARM9݂]AhX
    u32         length;             // ]oCg
    BOOL        isDMAC2;            // ]`F[̍ŌA9-DMAC1A9-DMAC2̂ǂg
    FirmHash    hash;               // f[^̃nbVl (HMAC-SHA-256)
}
FirmModule;

typedef struct FirmHeaderCore
{
    u32         magicNumber;
    u32         versionNumber;
    void*       entryAddressForMPCore;  // modulesΏ۔ԒnȊO̓G[ (MPCorePIFoRŒʒm)
    void*       entryAddressForARM9;    // A9-WRAMAmodulesΏ۔ԒnȊO̓G[
    u8          padding[48];            // modulesɉĂǂیŋ󂯂Ă
    FirmModule  modules[FIRM_FORMAT_MAX_MODULES];   // ԖڂǂɂĂR (A9-WRAMŌ?)
}
FirmHeaderCore;

typedef struct FirmHeder
{
    FirmHeaderCore  c;              // wb_{
    FirmSign        sign;           // FirmHeaderCorȅ (SHA-256)
}
FirmHeader;

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif // FORMAT_FIRM_H_
