/*---------------------------------------------------------------------------*
  Project:  CtrBrom - HW - include
  File:     mmap_tcm.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::           $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef FIRM_HW_ARM9_MMAP_TCM_H_
#define FIRM_HW_ARM9_MMAP_TCM_H_


#ifdef __cplusplus
extern "C" {
#endif

// DTCM

//------------------------------------- HW_FIRM_STACK
#define HW_FIRM_STACK                   (HW_FIRM_STACK_END - HW_FIRM_STACK_SIZE)
#define HW_FIRM_STACK_END               HW_DTCM_END
#define HW_FIRM_STACK_SIZE              0x1000  // 4KB

#define HW_FIRM_SVC_STACK               (HW_FIRM_SVC_STACK_END - HW_FIRM_SVC_STACK_SIZE)
#define HW_FIRM_SVC_STACK_END           HW_FIRM_STACK_END
#define HW_FIRM_SVC_STACK_SIZE          0x100  // 256B

#define HW_FIRM_IRQ_STACK               (HW_FIRM_IRQ_STACK_END - HW_FIRM_IRQ_STACK_SIZE)
#define HW_FIRM_IRQ_STACK_END           HW_FIRM_SVC_STACK
#define HW_FIRM_IRQ_STACK_SIZE          0x400  // 1KB

#define HW_FIRM_SYS_STACK               (HW_FIRM_SYS_STACK_END - HW_FIRM_SYS_STACK_SIZE)
#define HW_FIRM_SYS_STACK_END           HW_FIRM_IRQ_STACK
#define HW_FIRM_SYS_STACK_SIZE          (HW_FIRM_STACK_SIZE - HW_FIRM_IRQ_STACK_SIZE - HW_FIRM_SVC_STACK_SIZE)  // 2.75KB

// ITCM

//------------------------------------- HW_FIRM_CACHE_DEBUG_BUF
#define HW_FIRM_CACHE_DEBUG_BUF         HW_ITCM
#define HW_FIRM_CACHE_DEBUG_BUF_END     (HW_FIRM_CACHE_DEBUG_BUF + HW_FIRM_CACHE_DEBUG_BUF_SIZE)
#define HW_FIRM_CACHE_DEBUG_BUF_SIZE    (HW_ICACHE_SIZE + HW_DCACHE_SIZE + HW_ICACHE_TAG_SIZE + HW_DCACHE_TAG_SIZE)  // 13.5KB

//------------------------------------- HW_FIRM_FROM_BROM_BUF
#define HW_FIRM_FROM_BROM_BUF           (HW_FIRM_FROM_BROM_BUF_END - HW_FIRM_FROM_BROM_BUF_SIZE)
#define HW_FIRM_FROM_BROM_BUF_END       (HW_ITCM_END - 0x1000)  //  END - 4KB
#define HW_FIRM_FROM_BROM_BUF_SIZE      0x3000  // 12KB


#ifdef __cplusplus
} /* extern "C" */
#endif
/* FIRM_HW_ARM9_MMAP_TCM_H_ */
#endif
