/*---------------------------------------------------------------------------*
  Project:  CtrFirm - OS - include
  File:     svc_id.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef FIRM_OS_SVC_ID_H_
#define FIRM_OS_SVC_ID_H_

#include <ctr/types.h>

#ifdef __cplusplus
extern "C" {
#endif


#define SVC_ID_PREMASK              0x3f
#define SVC_ID_SHIFT                1

#define SVC_ID_SEMIHOST_ARM         0x12
#define SVC_ID_SEMIHOST_THUMB       0xab


typedef enum
{
    SVC_ID_DEC_SIGN = 34,
    SVC_ID_WAIT_BY_LOOP = 3,

    // reserve 0x2b for semihosting (0xab & 0x3f == 0x2b)
    // overlap semihosting ((0x123456>>16) & 0x3f == 0x12)
}
OSSvcID;


#ifdef __cplusplus
} /* extern "C" */
#endif

/* FIRM_OS_SVC_ID_H_ */
#endif
